package ch.uzh.ifi.attempto.aceeditor.grammar;

import java.util.ArrayList;
import java.util.HashMap;

import ch.uzh.ifi.attempto.chartparser.Nonterminal;
import ch.uzh.ifi.attempto.chartparser.Rule;
import ch.uzh.ifi.attempto.chartparser.StringRef;
import ch.uzh.ifi.attempto.chartparser.Terminal;
import ch.uzh.ifi.attempto.chartparser.Category;
import ch.uzh.ifi.attempto.chartparser.FeatureMap;

/**
 * This grammar class is automatically generated by the SWI Prolog program "generate_java.pl".
 */
@SuppressWarnings("all")
public class ACEGrammar extends ch.uzh.ifi.attempto.chartparser.Grammar {
	
	/**
	 * Creates a new grammar object.
	 */
	public ACEGrammar() {
		super("text");
		ArrayList<Category> l = new ArrayList<Category>();
		Category c;
		HashMap<Integer, StringRef> featureHash = new HashMap<Integer, StringRef>();
		
		// test=>declaration, fill
		l.clear();
		featureHash.clear();
		c = new Nonterminal("test");
		l.add(c);
		c = new Nonterminal("declaration");
		l.add(c);
		c = new Nonterminal("fill");
		l.add(c);
		addRule(new Rule(l, true));
		
		// test=>question, fill
		l.clear();
		featureHash.clear();
		c = new Nonterminal("test");
		l.add(c);
		c = new Nonterminal("question");
		l.add(c);
		c = new Nonterminal("fill");
		l.add(c);
		addRule(new Rule(l, true));
		
		// fill=>[]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("fill");
		l.add(c);
		addRule(new Rule(l, true));
		
		// fill=>[-], fill
		l.clear();
		featureHash.clear();
		c = new Nonterminal("fill");
		l.add(c);
		c = new Terminal("-");
		l.add(c);
		c = new Nonterminal("fill");
		l.add(c);
		addRule(new Rule(l, true));
		
		// text=>[]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("text");
		l.add(c);
		addRule(new Rule(l, true));
		
		// text=>declaration, text
		l.clear();
		featureHash.clear();
		c = new Nonterminal("text");
		l.add(c);
		c = new Nonterminal("declaration");
		l.add(c);
		c = new Nonterminal("text");
		l.add(c);
		addRule(new Rule(l, true));
		
		// text=>question
		l.clear();
		featureHash.clear();
		c = new Nonterminal("text");
		l.add(c);
		c = new Nonterminal("question");
		l.add(c);
		addRule(new Rule(l, true));
		
		// declaration=>sentence, ['.']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("declaration");
		l.add(c);
		c = new Nonterminal("sentence");
		l.add(c);
		c = new Terminal(".");
		l.add(c);
		addRule(new Rule(l, true));
		
		// question=>simple_sentence_2(whin:minus, whout:plus), [?]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("question");
		l.add(c);
		c = new Nonterminal("simple_sentence_2");
		c.setFeature("whin", new StringRef("minus"));
		c.setFeature("whout", new StringRef("plus"));
		l.add(c);
		c = new Terminal("?");
		l.add(c);
		addRule(new Rule(l, true));
		
		// sentence=>sentence_coord_1
		l.clear();
		featureHash.clear();
		c = new Nonterminal("sentence");
		l.add(c);
		c = new Nonterminal("sentence_coord_1");
		l.add(c);
		addRule(new Rule(l, true));
		
		// sentence~>['for every'], noun_constr, sentence_coord_1
		l.clear();
		featureHash.clear();
		c = new Nonterminal("sentence");
		l.add(c);
		c = new Terminal("for every");
		l.add(c);
		c = new Nonterminal("noun_constr");
		l.add(c);
		c = new Nonterminal("sentence_coord_1");
		l.add(c);
		addRule(new Rule(l, false));
		
		// sentence~>[if], sentence_coord_1, [then], sentence_coord_1
		l.clear();
		featureHash.clear();
		c = new Nonterminal("sentence");
		l.add(c);
		c = new Terminal("if");
		l.add(c);
		c = new Nonterminal("sentence_coord_1");
		l.add(c);
		c = new Terminal("then");
		l.add(c);
		c = new Nonterminal("sentence_coord_1");
		l.add(c);
		addRule(new Rule(l, false));
		
		// sentence_coord_1=>sentence_coord_2
		l.clear();
		featureHash.clear();
		c = new Nonterminal("sentence_coord_1");
		l.add(c);
		c = new Nonterminal("sentence_coord_2");
		l.add(c);
		addRule(new Rule(l, true));
		
		// sentence_coord_1~>sentence_coord_2, [or], sentence_coord_1
		l.clear();
		featureHash.clear();
		c = new Nonterminal("sentence_coord_1");
		l.add(c);
		c = new Nonterminal("sentence_coord_2");
		l.add(c);
		c = new Terminal("or");
		l.add(c);
		c = new Nonterminal("sentence_coord_1");
		l.add(c);
		addRule(new Rule(l, false));
		
		// sentence_coord_2=>simple_sentence
		l.clear();
		featureHash.clear();
		c = new Nonterminal("sentence_coord_2");
		l.add(c);
		c = new Nonterminal("simple_sentence");
		l.add(c);
		addRule(new Rule(l, true));
		
		// sentence_coord_2=>simple_sentence, [and], sentence_coord_2
		l.clear();
		featureHash.clear();
		c = new Nonterminal("sentence_coord_2");
		l.add(c);
		c = new Nonterminal("simple_sentence");
		l.add(c);
		c = new Terminal("and");
		l.add(c);
		c = new Nonterminal("sentence_coord_2");
		l.add(c);
		addRule(new Rule(l, true));
		
		// simple_sentence~>['it is false that'], simple_sentence_2(whin:minus, whout:minus)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("simple_sentence");
		l.add(c);
		c = new Terminal("it is false that");
		l.add(c);
		c = new Nonterminal("simple_sentence_2");
		c.setFeature("whin", new StringRef("minus"));
		c.setFeature("whout", new StringRef("minus"));
		l.add(c);
		addRule(new Rule(l, false));
		
		// simple_sentence=>['there is'], nounphrase(exist:plus, def:minus, pl:minus, whin:minus, whout:minus)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("simple_sentence");
		l.add(c);
		c = new Terminal("there is");
		l.add(c);
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("plus"));
		c.setFeature("def", new StringRef("minus"));
		c.setFeature("pl", new StringRef("minus"));
		c.setFeature("whin", new StringRef("minus"));
		c.setFeature("whout", new StringRef("minus"));
		l.add(c);
		addRule(new Rule(l, true));
		
		// simple_sentence=>['there is'], nounphrase(exist:plus, def:minus, pl:minus, whin:minus, whout:minus), ['such that'], simple_sentence
		l.clear();
		featureHash.clear();
		c = new Nonterminal("simple_sentence");
		l.add(c);
		c = new Terminal("there is");
		l.add(c);
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("plus"));
		c.setFeature("def", new StringRef("minus"));
		c.setFeature("pl", new StringRef("minus"));
		c.setFeature("whin", new StringRef("minus"));
		c.setFeature("whout", new StringRef("minus"));
		l.add(c);
		c = new Terminal("such that");
		l.add(c);
		c = new Nonterminal("simple_sentence");
		l.add(c);
		addRule(new Rule(l, true));
		
		// simple_sentence=>['there are'], nounphrase(exist:plus, def:minus, pl:plus, whin:minus, whout:minus)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("simple_sentence");
		l.add(c);
		c = new Terminal("there are");
		l.add(c);
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("plus"));
		c.setFeature("def", new StringRef("minus"));
		c.setFeature("pl", new StringRef("plus"));
		c.setFeature("whin", new StringRef("minus"));
		c.setFeature("whout", new StringRef("minus"));
		l.add(c);
		addRule(new Rule(l, true));
		
		// simple_sentence=>simple_sentence_2(whin:minus, whout:minus)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("simple_sentence");
		l.add(c);
		c = new Nonterminal("simple_sentence_2");
		c.setFeature("whin", new StringRef("minus"));
		c.setFeature("whout", new StringRef("minus"));
		l.add(c);
		addRule(new Rule(l, true));
		
		// simple_sentence_2(whin:A, whout:B)=>nounphrase(exist:plus, pl:C, whin:A, whout:D), verbphrase_coord_1(pl:C, whin:D, whout:B)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("simple_sentence_2");
		setFeature(c.getFeatureMap(), "whin", 0, featureHash);
		setFeature(c.getFeatureMap(), "whout", 1, featureHash);
		l.add(c);
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "pl", 2, featureHash);
		setFeature(c.getFeatureMap(), "whin", 0, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Nonterminal("verbphrase_coord_1");
		setFeature(c.getFeatureMap(), "pl", 2, featureHash);
		setFeature(c.getFeatureMap(), "whin", 3, featureHash);
		setFeature(c.getFeatureMap(), "whout", 1, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// simple_sentence_2(whin:A, whout:B)~>nounphrase(exist:minus, whin:A, whout:C), verbphrase_coord_1(pl:minus, whin:C, whout:B)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("simple_sentence_2");
		setFeature(c.getFeatureMap(), "whin", 0, featureHash);
		setFeature(c.getFeatureMap(), "whout", 1, featureHash);
		l.add(c);
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "whin", 0, featureHash);
		setFeature(c.getFeatureMap(), "whout", 2, featureHash);
		l.add(c);
		c = new Nonterminal("verbphrase_coord_1");
		c.setFeature("pl", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 1, featureHash);
		l.add(c);
		addRule(new Rule(l, false));
		
		// verbphrase_coord_1(pl:A, whin:B, whout:C)=>verbphrase_coord_2(pl:A, whin:B, whout:C)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("verbphrase_coord_1");
		setFeature(c.getFeatureMap(), "pl", 0, featureHash);
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 2, featureHash);
		l.add(c);
		c = new Nonterminal("verbphrase_coord_2");
		setFeature(c.getFeatureMap(), "pl", 0, featureHash);
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 2, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// verbphrase_coord_1(pl:A, whin:B, whout:C)~>verbphrase_coord_2(pl:A, whin:B, whout:D), [or], verbphrase_coord_1(pl:A, whin:D, whout:C)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("verbphrase_coord_1");
		setFeature(c.getFeatureMap(), "pl", 0, featureHash);
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 2, featureHash);
		l.add(c);
		c = new Nonterminal("verbphrase_coord_2");
		setFeature(c.getFeatureMap(), "pl", 0, featureHash);
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Terminal("or");
		l.add(c);
		c = new Nonterminal("verbphrase_coord_1");
		setFeature(c.getFeatureMap(), "pl", 0, featureHash);
		setFeature(c.getFeatureMap(), "whin", 3, featureHash);
		setFeature(c.getFeatureMap(), "whout", 2, featureHash);
		l.add(c);
		addRule(new Rule(l, false));
		
		// verbphrase_coord_2(pl:A, whin:B, whout:C)=>vp_cut(pl:A, whin:B, whout:C)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("verbphrase_coord_2");
		setFeature(c.getFeatureMap(), "pl", 0, featureHash);
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 2, featureHash);
		l.add(c);
		c = new Nonterminal("vp_cut");
		setFeature(c.getFeatureMap(), "pl", 0, featureHash);
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 2, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// verbphrase_coord_2(pl:A, whin:B, whout:C)=>vp_cut(pl:A, whin:B, whout:D), [and], verbphrase_coord_2(pl:A, whin:D, whout:C)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("verbphrase_coord_2");
		setFeature(c.getFeatureMap(), "pl", 0, featureHash);
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 2, featureHash);
		l.add(c);
		c = new Nonterminal("vp_cut");
		setFeature(c.getFeatureMap(), "pl", 0, featureHash);
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Terminal("and");
		l.add(c);
		c = new Nonterminal("verbphrase_coord_2");
		setFeature(c.getFeatureMap(), "pl", 0, featureHash);
		setFeature(c.getFeatureMap(), "whin", 3, featureHash);
		setFeature(c.getFeatureMap(), "whout", 2, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// vp_cut(rel:A, pl:B, whin:C, whout:D)=>vp(exists:plus, rel:A, pl:B, whin:C, whout:D)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("vp_cut");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "pl", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Nonterminal("vp");
		c.setFeature("exists", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "pl", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// vp_cut(rel:A, pl:B, whin:C, whout:D)~>vp(exists:minus, rel:A, pl:B, whin:C, whout:D)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("vp_cut");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "pl", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Nonterminal("vp");
		c.setFeature("exists", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "pl", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		addRule(new Rule(l, false));
		
		// vp(exists:A, rel:B, pl:C, whin:D, whout:E)=>auxiliary(be:F, exists:A, pl:C), vbar(be:F, exists:A, pl:C, rel:B, vform:inf, embv:G, copula:H, whin:D, whout:I), v_modifiers(embv:G, copula:H, whin:I, whout:E)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("vp");
		setFeature(c.getFeatureMap(), "exists", 0, featureHash);
		setFeature(c.getFeatureMap(), "rel", 1, featureHash);
		setFeature(c.getFeatureMap(), "pl", 2, featureHash);
		setFeature(c.getFeatureMap(), "whin", 3, featureHash);
		setFeature(c.getFeatureMap(), "whout", 4, featureHash);
		l.add(c);
		c = new Nonterminal("auxiliary");
		setFeature(c.getFeatureMap(), "be", 5, featureHash);
		setFeature(c.getFeatureMap(), "exists", 0, featureHash);
		setFeature(c.getFeatureMap(), "pl", 2, featureHash);
		l.add(c);
		c = new Nonterminal("vbar");
		setFeature(c.getFeatureMap(), "be", 5, featureHash);
		setFeature(c.getFeatureMap(), "exists", 0, featureHash);
		setFeature(c.getFeatureMap(), "pl", 2, featureHash);
		setFeature(c.getFeatureMap(), "rel", 1, featureHash);
		c.setFeature("vform", new StringRef("inf"));
		setFeature(c.getFeatureMap(), "embv", 6, featureHash);
		setFeature(c.getFeatureMap(), "copula", 7, featureHash);
		setFeature(c.getFeatureMap(), "whin", 3, featureHash);
		setFeature(c.getFeatureMap(), "whout", 8, featureHash);
		l.add(c);
		c = new Nonterminal("v_modifiers");
		setFeature(c.getFeatureMap(), "embv", 6, featureHash);
		setFeature(c.getFeatureMap(), "copula", 7, featureHash);
		setFeature(c.getFeatureMap(), "whin", 8, featureHash);
		setFeature(c.getFeatureMap(), "whout", 4, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// vp(exists:plus, rel:A, pl:B, whin:C, whout:D)=>vbar(be:minus, exists:plus, pl:B, rel:A, vform:fin, embv:E, copula:F, whin:C, whout:G), v_modifiers(embv:E, copula:F, whin:G, whout:D)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("vp");
		c.setFeature("exists", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "pl", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Nonterminal("vbar");
		c.setFeature("be", new StringRef("minus"));
		c.setFeature("exists", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "pl", 1, featureHash);
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		c.setFeature("vform", new StringRef("fin"));
		setFeature(c.getFeatureMap(), "embv", 4, featureHash);
		setFeature(c.getFeatureMap(), "copula", 5, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 6, featureHash);
		l.add(c);
		c = new Nonterminal("v_modifiers");
		setFeature(c.getFeatureMap(), "embv", 4, featureHash);
		setFeature(c.getFeatureMap(), "copula", 5, featureHash);
		setFeature(c.getFeatureMap(), "whin", 6, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// vbar(be:minus, exists:A, pl:B, vform:C, copula:minus, whin:D, whout:D)=>verb(vsubcat:itr, be:minus, pl:B, exists:A, vform:C)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("vbar");
		c.setFeature("be", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "exists", 0, featureHash);
		setFeature(c.getFeatureMap(), "pl", 1, featureHash);
		setFeature(c.getFeatureMap(), "vform", 2, featureHash);
		c.setFeature("copula", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "whin", 3, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Nonterminal("verb");
		c.setFeature("vsubcat", new StringRef("itr"));
		c.setFeature("be", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "pl", 1, featureHash);
		setFeature(c.getFeatureMap(), "exists", 0, featureHash);
		setFeature(c.getFeatureMap(), "vform", 2, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// vbar(be:minus, exists:A, rel:B, pl:C, vform:D, embv:E, copula:minus, whin:F, whout:G)=>verb(vsubcat:tr, be:minus, pl:C, exists:A, vform:D), nounphrase_cut(rel:B, vsubcat:tr, embv:E, whin:F, whout:G)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("vbar");
		c.setFeature("be", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "exists", 0, featureHash);
		setFeature(c.getFeatureMap(), "rel", 1, featureHash);
		setFeature(c.getFeatureMap(), "pl", 2, featureHash);
		setFeature(c.getFeatureMap(), "vform", 3, featureHash);
		setFeature(c.getFeatureMap(), "embv", 4, featureHash);
		c.setFeature("copula", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "whin", 5, featureHash);
		setFeature(c.getFeatureMap(), "whout", 6, featureHash);
		l.add(c);
		c = new Nonterminal("verb");
		c.setFeature("vsubcat", new StringRef("tr"));
		c.setFeature("be", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "pl", 2, featureHash);
		setFeature(c.getFeatureMap(), "exists", 0, featureHash);
		setFeature(c.getFeatureMap(), "vform", 3, featureHash);
		l.add(c);
		c = new Nonterminal("nounphrase_cut");
		setFeature(c.getFeatureMap(), "rel", 1, featureHash);
		c.setFeature("vsubcat", new StringRef("tr"));
		setFeature(c.getFeatureMap(), "embv", 4, featureHash);
		setFeature(c.getFeatureMap(), "whin", 5, featureHash);
		setFeature(c.getFeatureMap(), "whout", 6, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// vbar(be:plus, rel:A, embv:B, copula:minus, whin:C, whout:D)=>verb(vsubcat:tr, be:plus, pl:E, exists:F, vform:G), [by], nounphrase_cut(rel:A, copula:minus, embv:B, whin:C, whout:D)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("vbar");
		c.setFeature("be", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		c.setFeature("copula", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Nonterminal("verb");
		c.setFeature("vsubcat", new StringRef("tr"));
		c.setFeature("be", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "pl", 4, featureHash);
		setFeature(c.getFeatureMap(), "exists", 5, featureHash);
		setFeature(c.getFeatureMap(), "vform", 6, featureHash);
		l.add(c);
		c = new Terminal("by");
		l.add(c);
		c = new Nonterminal("nounphrase_cut");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		c.setFeature("copula", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// vbar(be:plus, rel:A, embv:B, copula:plus, whin:C, whout:D)=>nounphrase_cut(of:plus, rel:A, pl:minus, copula:plus, embv:B, whin:C, whout:D)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("vbar");
		c.setFeature("be", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		c.setFeature("copula", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Nonterminal("nounphrase_cut");
		c.setFeature("of", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		c.setFeature("pl", new StringRef("minus"));
		c.setFeature("copula", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// vbar(be:plus, rel:A, pl:minus, embv:B, copula:plus, whin:C, whout:D)=>nounphrase_cut(of:minus, rel:A, pl:minus, copula:plus, embv:B, whin:C, whout:D)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("vbar");
		c.setFeature("be", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		c.setFeature("pl", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		c.setFeature("copula", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Nonterminal("nounphrase_cut");
		c.setFeature("of", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		c.setFeature("pl", new StringRef("minus"));
		c.setFeature("copula", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// vbar(be:plus, rel:A, copula:plus, whin:B, whout:B)=>adj_coord
		l.clear();
		featureHash.clear();
		c = new Nonterminal("vbar");
		c.setFeature("be", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		c.setFeature("copula", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 1, featureHash);
		l.add(c);
		c = new Nonterminal("adj_coord");
		l.add(c);
		addRule(new Rule(l, true));
		
		// vbar(be:plus, rel:A, embv:B, copula:plus, whin:C, whout:D)=>compl_adj(rel:A, embv:B, whin:C, whout:D)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("vbar");
		c.setFeature("be", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		c.setFeature("copula", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Nonterminal("compl_adj");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// nounphrase_cut(exist:plus, rel:A, of:B, def:C, pl:D, copula:E, embv:F, whin:G, whout:H)=>nounphrase(exist:plus, rel:A, of:B, def:C, pl:D, copula:E, embv:F, whin:G, whout:H)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase_cut");
		c.setFeature("exist", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "of", 1, featureHash);
		setFeature(c.getFeatureMap(), "def", 2, featureHash);
		setFeature(c.getFeatureMap(), "pl", 3, featureHash);
		setFeature(c.getFeatureMap(), "copula", 4, featureHash);
		setFeature(c.getFeatureMap(), "embv", 5, featureHash);
		setFeature(c.getFeatureMap(), "whin", 6, featureHash);
		setFeature(c.getFeatureMap(), "whout", 7, featureHash);
		l.add(c);
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "of", 1, featureHash);
		setFeature(c.getFeatureMap(), "def", 2, featureHash);
		setFeature(c.getFeatureMap(), "pl", 3, featureHash);
		setFeature(c.getFeatureMap(), "copula", 4, featureHash);
		setFeature(c.getFeatureMap(), "embv", 5, featureHash);
		setFeature(c.getFeatureMap(), "whin", 6, featureHash);
		setFeature(c.getFeatureMap(), "whout", 7, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// nounphrase_cut(exist:minus, rel:A, of:B, def:C, pl:D, copula:E, embv:F, whin:G, whout:H)~>nounphrase(exist:minus, rel:A, of:B, def:C, pl:D, copula:E, embv:F, whin:G, whout:H)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase_cut");
		c.setFeature("exist", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "of", 1, featureHash);
		setFeature(c.getFeatureMap(), "def", 2, featureHash);
		setFeature(c.getFeatureMap(), "pl", 3, featureHash);
		setFeature(c.getFeatureMap(), "copula", 4, featureHash);
		setFeature(c.getFeatureMap(), "embv", 5, featureHash);
		setFeature(c.getFeatureMap(), "whin", 6, featureHash);
		setFeature(c.getFeatureMap(), "whout", 7, featureHash);
		l.add(c);
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "of", 1, featureHash);
		setFeature(c.getFeatureMap(), "def", 2, featureHash);
		setFeature(c.getFeatureMap(), "pl", 3, featureHash);
		setFeature(c.getFeatureMap(), "copula", 4, featureHash);
		setFeature(c.getFeatureMap(), "embv", 5, featureHash);
		setFeature(c.getFeatureMap(), "whin", 6, featureHash);
		setFeature(c.getFeatureMap(), "whout", 7, featureHash);
		l.add(c);
		addRule(new Rule(l, false));
		
		// nounphrase(exist:plus, rel:A, of:minus, def:plus, pl:minus, embv:B, whin:C, whout:D)=>propername(human:E), rel_phrase(rel:A, embv:B, human:E, whin:C, whout:D)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		c.setFeature("of", new StringRef("minus"));
		c.setFeature("def", new StringRef("plus"));
		c.setFeature("pl", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Nonterminal("propername");
		setFeature(c.getFeatureMap(), "human", 4, featureHash);
		l.add(c);
		c = new Nonterminal("rel_phrase");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "human", 4, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// nounphrase(exist:plus, of:minus, def:plus, pl:minus, whin:A, whout:A)=>var_ante
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("plus"));
		c.setFeature("of", new StringRef("minus"));
		c.setFeature("def", new StringRef("plus"));
		c.setFeature("pl", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "whin", 0, featureHash);
		setFeature(c.getFeatureMap(), "whout", 0, featureHash);
		l.add(c);
		c = new Nonterminal("var_ante");
		l.add(c);
		addRule(new Rule(l, true));
		
		// nounphrase(exist:plus, of:minus, def:plus, pl:minus, whin:A, whout:A)~>['DEF_NOUN_SG'(noun:B), 'REF'(text:C)], <<<(type:noun, hasvar:plus, noun:B, var:C)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("plus"));
		c.setFeature("of", new StringRef("minus"));
		c.setFeature("def", new StringRef("plus"));
		c.setFeature("pl", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "whin", 0, featureHash);
		setFeature(c.getFeatureMap(), "whout", 0, featureHash);
		l.add(c);
		c = new Terminal("DEF_NOUN_SG");
		setFeature(c.getFeatureMap(), "noun", 1, featureHash);
		l.add(c);
		c = new Terminal("REF");
		setFeature(c.getFeatureMap(), "text", 2, featureHash);
		l.add(c);
		c = new Nonterminal("<<<");
		c.setFeature("type", new StringRef("noun"));
		c.setFeature("hasvar", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "noun", 1, featureHash);
		setFeature(c.getFeatureMap(), "var", 2, featureHash);
		l.add(c);
		addRule(new Rule(l, false));
		
		// nounphrase(exist:plus, of:minus, def:plus, pl:minus, whin:A, whout:A)~>['DEF_NOUN_SG'(noun:B)], <<<(type:noun, noun:B)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("plus"));
		c.setFeature("of", new StringRef("minus"));
		c.setFeature("def", new StringRef("plus"));
		c.setFeature("pl", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "whin", 0, featureHash);
		setFeature(c.getFeatureMap(), "whout", 0, featureHash);
		l.add(c);
		c = new Terminal("DEF_NOUN_SG");
		setFeature(c.getFeatureMap(), "noun", 1, featureHash);
		l.add(c);
		c = new Nonterminal("<<<");
		c.setFeature("type", new StringRef("noun"));
		setFeature(c.getFeatureMap(), "noun", 1, featureHash);
		l.add(c);
		addRule(new Rule(l, false));
		
		// nounphrase(exist:plus, of:minus, def:plus, pl:minus, whin:A, whout:A)~>['REF'(text:B)], <<<(hasvar:plus, var:B)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("plus"));
		c.setFeature("of", new StringRef("minus"));
		c.setFeature("def", new StringRef("plus"));
		c.setFeature("pl", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "whin", 0, featureHash);
		setFeature(c.getFeatureMap(), "whout", 0, featureHash);
		l.add(c);
		c = new Terminal("REF");
		setFeature(c.getFeatureMap(), "text", 1, featureHash);
		l.add(c);
		c = new Nonterminal("<<<");
		c.setFeature("hasvar", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "var", 1, featureHash);
		l.add(c);
		addRule(new Rule(l, false));
		
		// nounphrase(exist:plus, rel:A, of:B, pl:minus, embv:C, whin:D, whout:E)=>[a], noun_constr(rel:A, of:B, embv:C, whin:D, whout:E)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "of", 1, featureHash);
		c.setFeature("pl", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "embv", 2, featureHash);
		setFeature(c.getFeatureMap(), "whin", 3, featureHash);
		setFeature(c.getFeatureMap(), "whout", 4, featureHash);
		l.add(c);
		c = new Terminal("a");
		l.add(c);
		c = new Nonterminal("noun_constr");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "of", 1, featureHash);
		setFeature(c.getFeatureMap(), "embv", 2, featureHash);
		setFeature(c.getFeatureMap(), "whin", 3, featureHash);
		setFeature(c.getFeatureMap(), "whout", 4, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// nounphrase(exist:plus, rel:A, of:B, pl:minus, embv:C, whin:D, whout:E)=>[an], noun_constr(rel:A, of:B, embv:C, whin:D, whout:E)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "of", 1, featureHash);
		c.setFeature("pl", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "embv", 2, featureHash);
		setFeature(c.getFeatureMap(), "whin", 3, featureHash);
		setFeature(c.getFeatureMap(), "whout", 4, featureHash);
		l.add(c);
		c = new Terminal("an");
		l.add(c);
		c = new Nonterminal("noun_constr");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "of", 1, featureHash);
		setFeature(c.getFeatureMap(), "embv", 2, featureHash);
		setFeature(c.getFeatureMap(), "whin", 3, featureHash);
		setFeature(c.getFeatureMap(), "whout", 4, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// nounphrase(exist:plus, rel:A, of:minus, pl:minus, embv:B, whin:C, whout:D)=>exist_anon(human:E), var_ante, rel_phrase(rel:A, embv:B, human:E, whin:C, whout:D)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		c.setFeature("of", new StringRef("minus"));
		c.setFeature("pl", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Nonterminal("exist_anon");
		setFeature(c.getFeatureMap(), "human", 4, featureHash);
		l.add(c);
		c = new Nonterminal("var_ante");
		l.add(c);
		c = new Nonterminal("rel_phrase");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "human", 4, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// nounphrase(exist:plus, rel:A, of:minus, pl:minus, embv:B, whin:C, whout:D)=>exist_anon(human:E), rel_phrase(rel:A, embv:B, human:E, whin:C, whout:D)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		c.setFeature("of", new StringRef("minus"));
		c.setFeature("pl", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Nonterminal("exist_anon");
		setFeature(c.getFeatureMap(), "human", 4, featureHash);
		l.add(c);
		c = new Nonterminal("rel_phrase");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "human", 4, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// nounphrase(exist:plus, of:minus, pl:plus, copula:minus, whin:A, whout:A)=>num_quant, ['NUM'], opt_adj_coord, ['NOUN_PL']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("plus"));
		c.setFeature("of", new StringRef("minus"));
		c.setFeature("pl", new StringRef("plus"));
		c.setFeature("copula", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "whin", 0, featureHash);
		setFeature(c.getFeatureMap(), "whout", 0, featureHash);
		l.add(c);
		c = new Nonterminal("num_quant");
		l.add(c);
		c = new Terminal("NUM");
		l.add(c);
		c = new Nonterminal("opt_adj_coord");
		l.add(c);
		c = new Terminal("NOUN_PL");
		l.add(c);
		addRule(new Rule(l, true));
		
		// nounphrase(exist:plus, of:minus, pl:minus, copula:minus, whin:A, whout:A)=>num_quant, [1], opt_adj_coord, ['NOUN_SG']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("plus"));
		c.setFeature("of", new StringRef("minus"));
		c.setFeature("pl", new StringRef("minus"));
		c.setFeature("copula", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "whin", 0, featureHash);
		setFeature(c.getFeatureMap(), "whout", 0, featureHash);
		l.add(c);
		c = new Nonterminal("num_quant");
		l.add(c);
		c = new Terminal("1");
		l.add(c);
		c = new Nonterminal("opt_adj_coord");
		l.add(c);
		c = new Terminal("NOUN_SG");
		l.add(c);
		addRule(new Rule(l, true));
		
		// nounphrase(exist:plus, of:minus, pl:minus, whout:plus)=>[what]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("plus"));
		c.setFeature("of", new StringRef("minus"));
		c.setFeature("pl", new StringRef("minus"));
		c.setFeature("whout", new StringRef("plus"));
		l.add(c);
		c = new Terminal("what");
		l.add(c);
		addRule(new Rule(l, true));
		
		// nounphrase(exist:plus, of:minus, pl:minus, whout:plus)=>[who]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("plus"));
		c.setFeature("of", new StringRef("minus"));
		c.setFeature("pl", new StringRef("minus"));
		c.setFeature("whout", new StringRef("plus"));
		l.add(c);
		c = new Terminal("who");
		l.add(c);
		addRule(new Rule(l, true));
		
		// nounphrase(exist:plus, rel:A, of:B, embv:C, pl:minus, whout:plus)=>[which], noun_constr(rel:A, of:B, embv:C, whin:plus, whout:plus)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "of", 1, featureHash);
		setFeature(c.getFeatureMap(), "embv", 2, featureHash);
		c.setFeature("pl", new StringRef("minus"));
		c.setFeature("whout", new StringRef("plus"));
		l.add(c);
		c = new Terminal("which");
		l.add(c);
		c = new Nonterminal("noun_constr");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "of", 1, featureHash);
		setFeature(c.getFeatureMap(), "embv", 2, featureHash);
		c.setFeature("whin", new StringRef("plus"));
		c.setFeature("whout", new StringRef("plus"));
		l.add(c);
		addRule(new Rule(l, true));
		
		// nounphrase(exist:plus, of:minus, pl:plus, whout:plus)=>[which], opt_adj_coord, ['NOUN_PL']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("plus"));
		c.setFeature("of", new StringRef("minus"));
		c.setFeature("pl", new StringRef("plus"));
		c.setFeature("whout", new StringRef("plus"));
		l.add(c);
		c = new Terminal("which");
		l.add(c);
		c = new Nonterminal("opt_adj_coord");
		l.add(c);
		c = new Terminal("NOUN_PL");
		l.add(c);
		addRule(new Rule(l, true));
		
		// nounphrase(exist:minus, rel:A, of:B, pl:minus, embv:C, whin:D, whout:E)=>[every], noun_constr(rel:A, of:B, embv:C, whin:D, whout:E)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "of", 1, featureHash);
		c.setFeature("pl", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "embv", 2, featureHash);
		setFeature(c.getFeatureMap(), "whin", 3, featureHash);
		setFeature(c.getFeatureMap(), "whout", 4, featureHash);
		l.add(c);
		c = new Terminal("every");
		l.add(c);
		c = new Nonterminal("noun_constr");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "of", 1, featureHash);
		setFeature(c.getFeatureMap(), "embv", 2, featureHash);
		setFeature(c.getFeatureMap(), "whin", 3, featureHash);
		setFeature(c.getFeatureMap(), "whout", 4, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// nounphrase(exist:minus, rel:A, of:minus, pl:minus, embv:B, whin:C, whout:D)=>univ_anon(human:E), var_ante, rel_phrase(rel:A, embv:B, human:E, whin:C, whout:D)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		c.setFeature("of", new StringRef("minus"));
		c.setFeature("pl", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Nonterminal("univ_anon");
		setFeature(c.getFeatureMap(), "human", 4, featureHash);
		l.add(c);
		c = new Nonterminal("var_ante");
		l.add(c);
		c = new Nonterminal("rel_phrase");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "human", 4, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// nounphrase(exist:minus, rel:A, of:minus, pl:minus, embv:B, whin:C, whout:D)=>univ_anon(human:E), rel_phrase(rel:A, embv:B, human:E, whin:C, whout:D)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		c.setFeature("of", new StringRef("minus"));
		c.setFeature("pl", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Nonterminal("univ_anon");
		setFeature(c.getFeatureMap(), "human", 4, featureHash);
		l.add(c);
		c = new Nonterminal("rel_phrase");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "human", 4, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// nounphrase(exist:minus, rel:A, of:B, pl:minus, embv:C, whin:D, whout:E)=>[no], noun_constr(rel:A, of:B, embv:C, whin:D, whout:E)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "of", 1, featureHash);
		c.setFeature("pl", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "embv", 2, featureHash);
		setFeature(c.getFeatureMap(), "whin", 3, featureHash);
		setFeature(c.getFeatureMap(), "whout", 4, featureHash);
		l.add(c);
		c = new Terminal("no");
		l.add(c);
		c = new Nonterminal("noun_constr");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "of", 1, featureHash);
		setFeature(c.getFeatureMap(), "embv", 2, featureHash);
		setFeature(c.getFeatureMap(), "whin", 3, featureHash);
		setFeature(c.getFeatureMap(), "whout", 4, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// nounphrase(exist:minus, rel:A, of:minus, pl:minus, embv:B, whin:C, whout:D)=>neg_anon(human:E), var_ante, rel_phrase(rel:A, embv:B, human:E, whin:C, whout:D)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		c.setFeature("of", new StringRef("minus"));
		c.setFeature("pl", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Nonterminal("neg_anon");
		setFeature(c.getFeatureMap(), "human", 4, featureHash);
		l.add(c);
		c = new Nonterminal("var_ante");
		l.add(c);
		c = new Nonterminal("rel_phrase");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "human", 4, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// nounphrase(exist:minus, rel:A, of:minus, pl:minus, embv:B, whin:C, whout:D)=>neg_anon(human:E), rel_phrase(rel:A, embv:B, human:E, whin:C, whout:D)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		c.setFeature("of", new StringRef("minus"));
		c.setFeature("pl", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Nonterminal("neg_anon");
		setFeature(c.getFeatureMap(), "human", 4, featureHash);
		l.add(c);
		c = new Nonterminal("rel_phrase");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "human", 4, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// noun_constr(rel:A, of:minus, embv:B, whin:C, whout:D)=>opt_adj_coord, noun_ante(human:E), rel_phrase(rel:A, embv:B, human:E, whin:C, whout:D)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("noun_constr");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		c.setFeature("of", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Nonterminal("opt_adj_coord");
		l.add(c);
		c = new Nonterminal("noun_ante");
		setFeature(c.getFeatureMap(), "human", 4, featureHash);
		l.add(c);
		c = new Nonterminal("rel_phrase");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "human", 4, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// noun_constr(rel:A, of:plus, embv:B, whin:C, whout:D)=>opt_adj_coord, ['NOUN_SG', of], nounphrase_cut(rel:A, embv:B, whin:C, whout:D)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("noun_constr");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		c.setFeature("of", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Nonterminal("opt_adj_coord");
		l.add(c);
		c = new Terminal("NOUN_SG");
		l.add(c);
		c = new Terminal("of");
		l.add(c);
		c = new Nonterminal("nounphrase_cut");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// noun_ante(human:A)=>['NOUN_SG'(human:A, text:B, id:C)], newvar(var:D), >>>(type:noun, hasvar:plus, noun:B, var:D, id:C)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("noun_ante");
		setFeature(c.getFeatureMap(), "human", 0, featureHash);
		l.add(c);
		c = new Terminal("NOUN_SG");
		setFeature(c.getFeatureMap(), "human", 0, featureHash);
		setFeature(c.getFeatureMap(), "text", 1, featureHash);
		setFeature(c.getFeatureMap(), "id", 2, featureHash);
		l.add(c);
		c = new Nonterminal("newvar");
		setFeature(c.getFeatureMap(), "var", 3, featureHash);
		l.add(c);
		c = new Nonterminal(">>>");
		c.setFeature("type", new StringRef("noun"));
		c.setFeature("hasvar", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "noun", 1, featureHash);
		setFeature(c.getFeatureMap(), "var", 3, featureHash);
		setFeature(c.getFeatureMap(), "id", 2, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// noun_ante(human:A)=>['NOUN_SG'(human:A, text:B, id:C)], >>>(type:noun, hasvar:minus, noun:B, id:C)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("noun_ante");
		setFeature(c.getFeatureMap(), "human", 0, featureHash);
		l.add(c);
		c = new Terminal("NOUN_SG");
		setFeature(c.getFeatureMap(), "human", 0, featureHash);
		setFeature(c.getFeatureMap(), "text", 1, featureHash);
		setFeature(c.getFeatureMap(), "id", 2, featureHash);
		l.add(c);
		c = new Nonterminal(">>>");
		c.setFeature("type", new StringRef("noun"));
		c.setFeature("hasvar", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "noun", 1, featureHash);
		setFeature(c.getFeatureMap(), "id", 2, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// var_ante=>newvar(var:A, id:B), >>>(type:var, hasvar:plus, var:A, id:B)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("var_ante");
		l.add(c);
		c = new Nonterminal("newvar");
		setFeature(c.getFeatureMap(), "var", 0, featureHash);
		setFeature(c.getFeatureMap(), "id", 1, featureHash);
		l.add(c);
		c = new Nonterminal(">>>");
		c.setFeature("type", new StringRef("var"));
		c.setFeature("hasvar", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "var", 0, featureHash);
		setFeature(c.getFeatureMap(), "id", 1, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// newvar(var:A)=>['VAR'(text:A)], </<(hasvar:plus, var:A)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("newvar");
		setFeature(c.getFeatureMap(), "var", 0, featureHash);
		l.add(c);
		c = new Terminal("VAR");
		setFeature(c.getFeatureMap(), "text", 0, featureHash);
		l.add(c);
		c = new Nonterminal("</<");
		c.setFeature("hasvar", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "var", 0, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// auxiliary(be:minus, exists:minus, pl:minus)=>['has to']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("auxiliary");
		c.setFeature("be", new StringRef("minus"));
		c.setFeature("exists", new StringRef("minus"));
		c.setFeature("pl", new StringRef("minus"));
		l.add(c);
		c = new Terminal("has to");
		l.add(c);
		addRule(new Rule(l, true));
		
		// auxiliary(be:minus, exists:minus, pl:plus)=>['have to']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("auxiliary");
		c.setFeature("be", new StringRef("minus"));
		c.setFeature("exists", new StringRef("minus"));
		c.setFeature("pl", new StringRef("plus"));
		l.add(c);
		c = new Terminal("have to");
		l.add(c);
		addRule(new Rule(l, true));
		
		// auxiliary(be:plus, exists:plus, pl:minus)=>[is]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("auxiliary");
		c.setFeature("be", new StringRef("plus"));
		c.setFeature("exists", new StringRef("plus"));
		c.setFeature("pl", new StringRef("minus"));
		l.add(c);
		c = new Terminal("is");
		l.add(c);
		addRule(new Rule(l, true));
		
		// auxiliary(be:plus, exists:minus, pl:minus)=>['is not']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("auxiliary");
		c.setFeature("be", new StringRef("plus"));
		c.setFeature("exists", new StringRef("minus"));
		c.setFeature("pl", new StringRef("minus"));
		l.add(c);
		c = new Terminal("is not");
		l.add(c);
		addRule(new Rule(l, true));
		
		// auxiliary(be:plus, exists:minus, pl:minus)=>[is, not]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("auxiliary");
		c.setFeature("be", new StringRef("plus"));
		c.setFeature("exists", new StringRef("minus"));
		c.setFeature("pl", new StringRef("minus"));
		l.add(c);
		c = new Terminal("is");
		l.add(c);
		c = new Terminal("not");
		l.add(c);
		addRule(new Rule(l, true));
		
		// auxiliary(be:plus, exists:plus, pl:plus)=>[are]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("auxiliary");
		c.setFeature("be", new StringRef("plus"));
		c.setFeature("exists", new StringRef("plus"));
		c.setFeature("pl", new StringRef("plus"));
		l.add(c);
		c = new Terminal("are");
		l.add(c);
		addRule(new Rule(l, true));
		
		// auxiliary(be:plus, exists:minus, pl:plus)=>['are not']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("auxiliary");
		c.setFeature("be", new StringRef("plus"));
		c.setFeature("exists", new StringRef("minus"));
		c.setFeature("pl", new StringRef("plus"));
		l.add(c);
		c = new Terminal("are not");
		l.add(c);
		addRule(new Rule(l, true));
		
		// auxiliary(be:plus, exists:minus, pl:plus)=>[are, not]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("auxiliary");
		c.setFeature("be", new StringRef("plus"));
		c.setFeature("exists", new StringRef("minus"));
		c.setFeature("pl", new StringRef("plus"));
		l.add(c);
		c = new Terminal("are");
		l.add(c);
		c = new Terminal("not");
		l.add(c);
		addRule(new Rule(l, true));
		
		// auxiliary(be:minus, exists:minus, pl:minus)=>['does not']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("auxiliary");
		c.setFeature("be", new StringRef("minus"));
		c.setFeature("exists", new StringRef("minus"));
		c.setFeature("pl", new StringRef("minus"));
		l.add(c);
		c = new Terminal("does not");
		l.add(c);
		addRule(new Rule(l, true));
		
		// auxiliary(be:minus, exists:minus, pl:plus)=>['do not']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("auxiliary");
		c.setFeature("be", new StringRef("minus"));
		c.setFeature("exists", new StringRef("minus"));
		c.setFeature("pl", new StringRef("plus"));
		l.add(c);
		c = new Terminal("do not");
		l.add(c);
		addRule(new Rule(l, true));
		
		// auxiliary(be:minus, exists:minus)=>[can]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("auxiliary");
		c.setFeature("be", new StringRef("minus"));
		c.setFeature("exists", new StringRef("minus"));
		l.add(c);
		c = new Terminal("can");
		l.add(c);
		addRule(new Rule(l, true));
		
		// auxiliary(be:minus, exists:minus)=>[should]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("auxiliary");
		c.setFeature("be", new StringRef("minus"));
		c.setFeature("exists", new StringRef("minus"));
		l.add(c);
		c = new Terminal("should");
		l.add(c);
		addRule(new Rule(l, true));
		
		// auxiliary(be:minus, exists:minus)=>[must]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("auxiliary");
		c.setFeature("be", new StringRef("minus"));
		c.setFeature("exists", new StringRef("minus"));
		l.add(c);
		c = new Terminal("must");
		l.add(c);
		addRule(new Rule(l, true));
		
		// auxiliary(be:plus, exists:minus)=>[can, be]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("auxiliary");
		c.setFeature("be", new StringRef("plus"));
		c.setFeature("exists", new StringRef("minus"));
		l.add(c);
		c = new Terminal("can");
		l.add(c);
		c = new Terminal("be");
		l.add(c);
		addRule(new Rule(l, true));
		
		// auxiliary(be:plus, exists:minus)=>[should, be]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("auxiliary");
		c.setFeature("be", new StringRef("plus"));
		c.setFeature("exists", new StringRef("minus"));
		l.add(c);
		c = new Terminal("should");
		l.add(c);
		c = new Terminal("be");
		l.add(c);
		addRule(new Rule(l, true));
		
		// auxiliary(be:plus, exists:minus)=>[must, be]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("auxiliary");
		c.setFeature("be", new StringRef("plus"));
		c.setFeature("exists", new StringRef("minus"));
		l.add(c);
		c = new Terminal("must");
		l.add(c);
		c = new Terminal("be");
		l.add(c);
		addRule(new Rule(l, true));
		
		// auxiliary(be:plus, exists:minus, pl:minus)=>['has to', be]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("auxiliary");
		c.setFeature("be", new StringRef("plus"));
		c.setFeature("exists", new StringRef("minus"));
		c.setFeature("pl", new StringRef("minus"));
		l.add(c);
		c = new Terminal("has to");
		l.add(c);
		c = new Terminal("be");
		l.add(c);
		addRule(new Rule(l, true));
		
		// auxiliary(be:plus, exists:minus, pl:plus)=>['have to', be]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("auxiliary");
		c.setFeature("be", new StringRef("plus"));
		c.setFeature("exists", new StringRef("minus"));
		c.setFeature("pl", new StringRef("plus"));
		l.add(c);
		c = new Terminal("have to");
		l.add(c);
		c = new Terminal("be");
		l.add(c);
		addRule(new Rule(l, true));
		
		// auxiliary(be:plus, exists:minus)=>[cannot, be]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("auxiliary");
		c.setFeature("be", new StringRef("plus"));
		c.setFeature("exists", new StringRef("minus"));
		l.add(c);
		c = new Terminal("cannot");
		l.add(c);
		c = new Terminal("be");
		l.add(c);
		addRule(new Rule(l, true));
		
		// auxiliary(be:plus, exists:minus)=>[can, not, be]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("auxiliary");
		c.setFeature("be", new StringRef("plus"));
		c.setFeature("exists", new StringRef("minus"));
		l.add(c);
		c = new Terminal("can");
		l.add(c);
		c = new Terminal("not");
		l.add(c);
		c = new Terminal("be");
		l.add(c);
		addRule(new Rule(l, true));
		
		// auxiliary(be:plus, exists:minus)=>[should, not, be]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("auxiliary");
		c.setFeature("be", new StringRef("plus"));
		c.setFeature("exists", new StringRef("minus"));
		l.add(c);
		c = new Terminal("should");
		l.add(c);
		c = new Terminal("not");
		l.add(c);
		c = new Terminal("be");
		l.add(c);
		addRule(new Rule(l, true));
		
		// auxiliary(be:plus, exists:minus, pl:minus)=>['does not', 'have to', be]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("auxiliary");
		c.setFeature("be", new StringRef("plus"));
		c.setFeature("exists", new StringRef("minus"));
		c.setFeature("pl", new StringRef("minus"));
		l.add(c);
		c = new Terminal("does not");
		l.add(c);
		c = new Terminal("have to");
		l.add(c);
		c = new Terminal("be");
		l.add(c);
		addRule(new Rule(l, true));
		
		// auxiliary(be:plus, exists:minus, pl:plus)=>['do not', 'have to', be]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("auxiliary");
		c.setFeature("be", new StringRef("plus"));
		c.setFeature("exists", new StringRef("minus"));
		c.setFeature("pl", new StringRef("plus"));
		l.add(c);
		c = new Terminal("do not");
		l.add(c);
		c = new Terminal("have to");
		l.add(c);
		c = new Terminal("be");
		l.add(c);
		addRule(new Rule(l, true));
		
		// auxiliary(be:minus, exists:minus, pl:minus)=>[cannot]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("auxiliary");
		c.setFeature("be", new StringRef("minus"));
		c.setFeature("exists", new StringRef("minus"));
		c.setFeature("pl", new StringRef("minus"));
		l.add(c);
		c = new Terminal("cannot");
		l.add(c);
		addRule(new Rule(l, true));
		
		// auxiliary(be:minus, exists:minus, pl:minus)=>[can, not]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("auxiliary");
		c.setFeature("be", new StringRef("minus"));
		c.setFeature("exists", new StringRef("minus"));
		c.setFeature("pl", new StringRef("minus"));
		l.add(c);
		c = new Terminal("can");
		l.add(c);
		c = new Terminal("not");
		l.add(c);
		addRule(new Rule(l, true));
		
		// auxiliary(be:minus, exists:minus, pl:minus)=>[should, not]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("auxiliary");
		c.setFeature("be", new StringRef("minus"));
		c.setFeature("exists", new StringRef("minus"));
		c.setFeature("pl", new StringRef("minus"));
		l.add(c);
		c = new Terminal("should");
		l.add(c);
		c = new Terminal("not");
		l.add(c);
		addRule(new Rule(l, true));
		
		// auxiliary(be:minus, exists:minus, pl:minus)=>['does not', 'have to']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("auxiliary");
		c.setFeature("be", new StringRef("minus"));
		c.setFeature("exists", new StringRef("minus"));
		c.setFeature("pl", new StringRef("minus"));
		l.add(c);
		c = new Terminal("does not");
		l.add(c);
		c = new Terminal("have to");
		l.add(c);
		addRule(new Rule(l, true));
		
		// auxiliary(be:minus, exists:minus, pl:plus)=>['do not', 'have to']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("auxiliary");
		c.setFeature("be", new StringRef("minus"));
		c.setFeature("exists", new StringRef("minus"));
		c.setFeature("pl", new StringRef("plus"));
		l.add(c);
		c = new Terminal("do not");
		l.add(c);
		c = new Terminal("have to");
		l.add(c);
		addRule(new Rule(l, true));
		
		// verb(be:minus, vsubcat:itr, pl:minus, vform:fin)=>['IV_FINSG']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("verb");
		c.setFeature("be", new StringRef("minus"));
		c.setFeature("vsubcat", new StringRef("itr"));
		c.setFeature("pl", new StringRef("minus"));
		c.setFeature("vform", new StringRef("fin"));
		l.add(c);
		c = new Terminal("IV_FINSG");
		l.add(c);
		addRule(new Rule(l, true));
		
		// verb(be:minus, vsubcat:itr, pl:plus, vform:fin)=>['IV_INFPL']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("verb");
		c.setFeature("be", new StringRef("minus"));
		c.setFeature("vsubcat", new StringRef("itr"));
		c.setFeature("pl", new StringRef("plus"));
		c.setFeature("vform", new StringRef("fin"));
		l.add(c);
		c = new Terminal("IV_INFPL");
		l.add(c);
		addRule(new Rule(l, true));
		
		// verb(be:minus, vsubcat:itr, vform:inf)=>['IV_INFPL']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("verb");
		c.setFeature("be", new StringRef("minus"));
		c.setFeature("vsubcat", new StringRef("itr"));
		c.setFeature("vform", new StringRef("inf"));
		l.add(c);
		c = new Terminal("IV_INFPL");
		l.add(c);
		addRule(new Rule(l, true));
		
		// verb(be:minus, vsubcat:tr, pl:minus, vform:fin)=>['TV_FINSG']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("verb");
		c.setFeature("be", new StringRef("minus"));
		c.setFeature("vsubcat", new StringRef("tr"));
		c.setFeature("pl", new StringRef("minus"));
		c.setFeature("vform", new StringRef("fin"));
		l.add(c);
		c = new Terminal("TV_FINSG");
		l.add(c);
		addRule(new Rule(l, true));
		
		// verb(be:minus, vsubcat:tr, pl:plus, vform:fin)=>['TV_INFPL']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("verb");
		c.setFeature("be", new StringRef("minus"));
		c.setFeature("vsubcat", new StringRef("tr"));
		c.setFeature("pl", new StringRef("plus"));
		c.setFeature("vform", new StringRef("fin"));
		l.add(c);
		c = new Terminal("TV_INFPL");
		l.add(c);
		addRule(new Rule(l, true));
		
		// verb(be:minus, vsubcat:tr, vform:inf)=>['TV_INFPL']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("verb");
		c.setFeature("be", new StringRef("minus"));
		c.setFeature("vsubcat", new StringRef("tr"));
		c.setFeature("vform", new StringRef("inf"));
		l.add(c);
		c = new Terminal("TV_INFPL");
		l.add(c);
		addRule(new Rule(l, true));
		
		// verb(be:plus, vsubcat:tr)=>['TV_PP']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("verb");
		c.setFeature("be", new StringRef("plus"));
		c.setFeature("vsubcat", new StringRef("tr"));
		l.add(c);
		c = new Terminal("TV_PP");
		l.add(c);
		addRule(new Rule(l, true));
		
		// rel_phrase(whin:A, whout:A)=>[]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("rel_phrase");
		setFeature(c.getFeatureMap(), "whin", 0, featureHash);
		setFeature(c.getFeatureMap(), "whout", 0, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// rel_phrase(rel:plus, embv:plus, human:A, whin:B, whout:C)=>rel_pron(human:A, relpron:D), rel_phrase_1(human:A, relpron:D, whin:B, whout:C)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("rel_phrase");
		c.setFeature("rel", new StringRef("plus"));
		c.setFeature("embv", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "human", 0, featureHash);
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 2, featureHash);
		l.add(c);
		c = new Nonterminal("rel_pron");
		setFeature(c.getFeatureMap(), "human", 0, featureHash);
		setFeature(c.getFeatureMap(), "relpron", 3, featureHash);
		l.add(c);
		c = new Nonterminal("rel_phrase_1");
		setFeature(c.getFeatureMap(), "human", 0, featureHash);
		setFeature(c.getFeatureMap(), "relpron", 3, featureHash);
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 2, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// rel_phrase_1(human:A, relpron:B, whin:C, whout:D)~>rel_phrase_2(human:A, rel:minus, relpron:B, whin:C, whout:E), or_rel_pron(human:A, relpron:B), rel_phrase_1(human:A, relpron:B, whin:E, whout:D)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("rel_phrase_1");
		setFeature(c.getFeatureMap(), "human", 0, featureHash);
		setFeature(c.getFeatureMap(), "relpron", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Nonterminal("rel_phrase_2");
		setFeature(c.getFeatureMap(), "human", 0, featureHash);
		c.setFeature("rel", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "relpron", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 4, featureHash);
		l.add(c);
		c = new Nonterminal("or_rel_pron");
		setFeature(c.getFeatureMap(), "human", 0, featureHash);
		setFeature(c.getFeatureMap(), "relpron", 1, featureHash);
		l.add(c);
		c = new Nonterminal("rel_phrase_1");
		setFeature(c.getFeatureMap(), "human", 0, featureHash);
		setFeature(c.getFeatureMap(), "relpron", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 4, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		addRule(new Rule(l, false));
		
		// rel_phrase_1(human:A, relpron:B, whin:C, whout:D)=>rel_phrase_2(human:A, relpron:B, whin:C, whout:D)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("rel_phrase_1");
		setFeature(c.getFeatureMap(), "human", 0, featureHash);
		setFeature(c.getFeatureMap(), "relpron", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Nonterminal("rel_phrase_2");
		setFeature(c.getFeatureMap(), "human", 0, featureHash);
		setFeature(c.getFeatureMap(), "relpron", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// rel_phrase_2(rel:A, relpron:B, human:C, whin:D, whout:E)=>vp_cut(rel:minus, pl:minus, whin:D, whout:F), and_rel_pron(human:C, relpron:B), rel_phrase_2(rel:A, relpron:B, human:C, whin:F, whout:E)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("rel_phrase_2");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "relpron", 1, featureHash);
		setFeature(c.getFeatureMap(), "human", 2, featureHash);
		setFeature(c.getFeatureMap(), "whin", 3, featureHash);
		setFeature(c.getFeatureMap(), "whout", 4, featureHash);
		l.add(c);
		c = new Nonterminal("vp_cut");
		c.setFeature("rel", new StringRef("minus"));
		c.setFeature("pl", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "whin", 3, featureHash);
		setFeature(c.getFeatureMap(), "whout", 5, featureHash);
		l.add(c);
		c = new Nonterminal("and_rel_pron");
		setFeature(c.getFeatureMap(), "human", 2, featureHash);
		setFeature(c.getFeatureMap(), "relpron", 1, featureHash);
		l.add(c);
		c = new Nonterminal("rel_phrase_2");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "relpron", 1, featureHash);
		setFeature(c.getFeatureMap(), "human", 2, featureHash);
		setFeature(c.getFeatureMap(), "whin", 5, featureHash);
		setFeature(c.getFeatureMap(), "whout", 4, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// rel_phrase_2(rel:A, whin:B, whout:C)=>vp_cut(rel:A, pl:minus, whin:B, whout:C)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("rel_phrase_2");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 2, featureHash);
		l.add(c);
		c = new Nonterminal("vp_cut");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		c.setFeature("pl", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 2, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// rel_phrase_2(rel:A, whin:B, whout:C)=>nounphrase_cut(rel:minus, copula:minus, pl:D, embv:E, whin:B, whout:F), auxiliary(be:minus, exists:G, pl:D), verb(vsubcat:tr, be:minus, exists:G, pl:D, vform:inf), v_modifiers(rel:A, embv:E, copula:minus, whin:F, whout:C)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("rel_phrase_2");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 2, featureHash);
		l.add(c);
		c = new Nonterminal("nounphrase_cut");
		c.setFeature("rel", new StringRef("minus"));
		c.setFeature("copula", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "pl", 3, featureHash);
		setFeature(c.getFeatureMap(), "embv", 4, featureHash);
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 5, featureHash);
		l.add(c);
		c = new Nonterminal("auxiliary");
		c.setFeature("be", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "exists", 6, featureHash);
		setFeature(c.getFeatureMap(), "pl", 3, featureHash);
		l.add(c);
		c = new Nonterminal("verb");
		c.setFeature("vsubcat", new StringRef("tr"));
		c.setFeature("be", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "exists", 6, featureHash);
		setFeature(c.getFeatureMap(), "pl", 3, featureHash);
		c.setFeature("vform", new StringRef("inf"));
		l.add(c);
		c = new Nonterminal("v_modifiers");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "embv", 4, featureHash);
		c.setFeature("copula", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "whin", 5, featureHash);
		setFeature(c.getFeatureMap(), "whout", 2, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// rel_phrase_2(rel:A, whin:B, whout:C)=>nounphrase_cut(rel:minus, copula:minus, pl:D, embv:E, whin:B, whout:F), verb(vsubcat:tr, be:minus, exists:plus, pl:D, vform:fin), v_modifiers(rel:A, embv:E, copula:minus, whin:F, whout:C)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("rel_phrase_2");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 2, featureHash);
		l.add(c);
		c = new Nonterminal("nounphrase_cut");
		c.setFeature("rel", new StringRef("minus"));
		c.setFeature("copula", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "pl", 3, featureHash);
		setFeature(c.getFeatureMap(), "embv", 4, featureHash);
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 5, featureHash);
		l.add(c);
		c = new Nonterminal("verb");
		c.setFeature("vsubcat", new StringRef("tr"));
		c.setFeature("be", new StringRef("minus"));
		c.setFeature("exists", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "pl", 3, featureHash);
		c.setFeature("vform", new StringRef("fin"));
		l.add(c);
		c = new Nonterminal("v_modifiers");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "embv", 4, featureHash);
		c.setFeature("copula", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "whin", 5, featureHash);
		setFeature(c.getFeatureMap(), "whout", 2, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// rel_pron(relpron:that)=>[that]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("rel_pron");
		c.setFeature("relpron", new StringRef("that"));
		l.add(c);
		c = new Terminal("that");
		l.add(c);
		addRule(new Rule(l, true));
		
		// rel_pron(human:plus, relpron:who)=>[who]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("rel_pron");
		c.setFeature("human", new StringRef("plus"));
		c.setFeature("relpron", new StringRef("who"));
		l.add(c);
		c = new Terminal("who");
		l.add(c);
		addRule(new Rule(l, true));
		
		// rel_pron(human:minus, relpron:which)=>[which]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("rel_pron");
		c.setFeature("human", new StringRef("minus"));
		c.setFeature("relpron", new StringRef("which"));
		l.add(c);
		c = new Terminal("which");
		l.add(c);
		addRule(new Rule(l, true));
		
		// or_rel_pron(human:A, relpron:B)=>[or], rel_pron(human:A, relpron:B)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("or_rel_pron");
		setFeature(c.getFeatureMap(), "human", 0, featureHash);
		setFeature(c.getFeatureMap(), "relpron", 1, featureHash);
		l.add(c);
		c = new Terminal("or");
		l.add(c);
		c = new Nonterminal("rel_pron");
		setFeature(c.getFeatureMap(), "human", 0, featureHash);
		setFeature(c.getFeatureMap(), "relpron", 1, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// or_rel_pron(relpron:that)=>['or that']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("or_rel_pron");
		c.setFeature("relpron", new StringRef("that"));
		l.add(c);
		c = new Terminal("or that");
		l.add(c);
		addRule(new Rule(l, true));
		
		// or_rel_pron(human:plus, relpron:who)=>['or who']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("or_rel_pron");
		c.setFeature("human", new StringRef("plus"));
		c.setFeature("relpron", new StringRef("who"));
		l.add(c);
		c = new Terminal("or who");
		l.add(c);
		addRule(new Rule(l, true));
		
		// or_rel_pron(human:minus, relpron:which)=>['or which']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("or_rel_pron");
		c.setFeature("human", new StringRef("minus"));
		c.setFeature("relpron", new StringRef("which"));
		l.add(c);
		c = new Terminal("or which");
		l.add(c);
		addRule(new Rule(l, true));
		
		// and_rel_pron(human:A, relpron:B)=>[and], rel_pron(human:A, relpron:B)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("and_rel_pron");
		setFeature(c.getFeatureMap(), "human", 0, featureHash);
		setFeature(c.getFeatureMap(), "relpron", 1, featureHash);
		l.add(c);
		c = new Terminal("and");
		l.add(c);
		c = new Nonterminal("rel_pron");
		setFeature(c.getFeatureMap(), "human", 0, featureHash);
		setFeature(c.getFeatureMap(), "relpron", 1, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// and_rel_pron(relpron:that)=>['and that']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("and_rel_pron");
		c.setFeature("relpron", new StringRef("that"));
		l.add(c);
		c = new Terminal("and that");
		l.add(c);
		addRule(new Rule(l, true));
		
		// and_rel_pron(human:plus, relpron:who)=>['and who']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("and_rel_pron");
		c.setFeature("human", new StringRef("plus"));
		c.setFeature("relpron", new StringRef("who"));
		l.add(c);
		c = new Terminal("and who");
		l.add(c);
		addRule(new Rule(l, true));
		
		// and_rel_pron(human:minus, relpron:which)=>['and which']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("and_rel_pron");
		c.setFeature("human", new StringRef("minus"));
		c.setFeature("relpron", new StringRef("which"));
		l.add(c);
		c = new Terminal("and which");
		l.add(c);
		addRule(new Rule(l, true));
		
		// opt_adj_coord=>[]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("opt_adj_coord");
		l.add(c);
		addRule(new Rule(l, true));
		
		// opt_adj_coord=>adj_coord
		l.clear();
		featureHash.clear();
		c = new Nonterminal("opt_adj_coord");
		l.add(c);
		c = new Nonterminal("adj_coord");
		l.add(c);
		addRule(new Rule(l, true));
		
		// adj_coord=>adj_itr
		l.clear();
		featureHash.clear();
		c = new Nonterminal("adj_coord");
		l.add(c);
		c = new Nonterminal("adj_itr");
		l.add(c);
		addRule(new Rule(l, true));
		
		// adj_coord=>adj_itr, [and], adj_coord
		l.clear();
		featureHash.clear();
		c = new Nonterminal("adj_coord");
		l.add(c);
		c = new Nonterminal("adj_itr");
		l.add(c);
		c = new Terminal("and");
		l.add(c);
		c = new Nonterminal("adj_coord");
		l.add(c);
		addRule(new Rule(l, true));
		
		// adj_itr=>['ADJ_ITR']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("adj_itr");
		l.add(c);
		c = new Terminal("ADJ_ITR");
		l.add(c);
		addRule(new Rule(l, true));
		
		// adj_itr=>[more, 'ADJ_ITR']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("adj_itr");
		l.add(c);
		c = new Terminal("more");
		l.add(c);
		c = new Terminal("ADJ_ITR");
		l.add(c);
		addRule(new Rule(l, true));
		
		// adj_itr=>['ADJ_ITR_COMP']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("adj_itr");
		l.add(c);
		c = new Terminal("ADJ_ITR_COMP");
		l.add(c);
		addRule(new Rule(l, true));
		
		// adj_itr=>[most, 'ADJ_ITR']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("adj_itr");
		l.add(c);
		c = new Terminal("most");
		l.add(c);
		c = new Terminal("ADJ_ITR");
		l.add(c);
		addRule(new Rule(l, true));
		
		// adj_itr=>['ADJ_ITR_SUP']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("adj_itr");
		l.add(c);
		c = new Terminal("ADJ_ITR_SUP");
		l.add(c);
		addRule(new Rule(l, true));
		
		// compl_adj(rel:A, embv:B, whin:C, whout:D)=>[as, 'ADJ_ITR', as], nounphrase_cut(rel:A, copula:minus, embv:B, whin:C, whout:D)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("compl_adj");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Terminal("as");
		l.add(c);
		c = new Terminal("ADJ_ITR");
		l.add(c);
		c = new Terminal("as");
		l.add(c);
		c = new Nonterminal("nounphrase_cut");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		c.setFeature("copula", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// compl_adj(rel:A, embv:B, whin:C, whout:D)=>['ADJ_ITR_COMP', than], nounphrase_cut(rel:A, copula:minus, embv:B, whin:C, whout:D)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("compl_adj");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Terminal("ADJ_ITR_COMP");
		l.add(c);
		c = new Terminal("than");
		l.add(c);
		c = new Nonterminal("nounphrase_cut");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		c.setFeature("copula", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// compl_adj(rel:A, embv:B, whin:C, whout:D)=>[more, 'ADJ_ITR', than], nounphrase_cut(rel:A, copula:minus, embv:B, whin:C, whout:D)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("compl_adj");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Terminal("more");
		l.add(c);
		c = new Terminal("ADJ_ITR");
		l.add(c);
		c = new Terminal("than");
		l.add(c);
		c = new Nonterminal("nounphrase_cut");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		c.setFeature("copula", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// compl_adj(rel:A, embv:B, whin:C, whout:D)=>['ADJ_TR'], nounphrase_cut(rel:A, copula:minus, embv:B, whin:C, whout:D)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("compl_adj");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Terminal("ADJ_TR");
		l.add(c);
		c = new Nonterminal("nounphrase_cut");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		c.setFeature("copula", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// compl_adj(rel:A, embv:B, whin:C, whout:D)=>[more, 'ADJ_TR'], nounphrase_cut(rel:A, copula:minus, embv:B, whin:C, whout:E)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("compl_adj");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Terminal("more");
		l.add(c);
		c = new Terminal("ADJ_TR");
		l.add(c);
		c = new Nonterminal("nounphrase_cut");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		c.setFeature("copula", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 4, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// compl_adj(rel:A, embv:B, whin:C, whout:D)=>[most, 'ADJ_TR'], nounphrase_cut(rel:A, copula:minus, embv:B, whin:C, whout:E)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("compl_adj");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Terminal("most");
		l.add(c);
		c = new Terminal("ADJ_TR");
		l.add(c);
		c = new Nonterminal("nounphrase_cut");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		c.setFeature("copula", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 4, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// compl_adj(rel:A, embv:B, whin:C, whout:D)=>[as, 'ADJ_TR'], nounphrase_cut(rel:minus, copula:minus, embv:B, whin:C, whout:E), [as], nounphrase_cut(rel:A, copula:minus, embv:B, whin:E, whout:D)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("compl_adj");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Terminal("as");
		l.add(c);
		c = new Terminal("ADJ_TR");
		l.add(c);
		c = new Nonterminal("nounphrase_cut");
		c.setFeature("rel", new StringRef("minus"));
		c.setFeature("copula", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 4, featureHash);
		l.add(c);
		c = new Terminal("as");
		l.add(c);
		c = new Nonterminal("nounphrase_cut");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		c.setFeature("copula", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 4, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// compl_adj(rel:A, embv:B, whin:C, whout:D)=>[as, 'ADJ_TR'(prep:E)], nounphrase_cut(rel:minus, copula:minus, embv:B, whin:C, whout:F), [as, 'ADJ_TR_PREP'(prep:E)], nounphrase_cut(rel:A, copula:minus, embv:B, whin:F, whout:D)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("compl_adj");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Terminal("as");
		l.add(c);
		c = new Terminal("ADJ_TR");
		setFeature(c.getFeatureMap(), "prep", 4, featureHash);
		l.add(c);
		c = new Nonterminal("nounphrase_cut");
		c.setFeature("rel", new StringRef("minus"));
		c.setFeature("copula", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 5, featureHash);
		l.add(c);
		c = new Terminal("as");
		l.add(c);
		c = new Terminal("ADJ_TR_PREP");
		setFeature(c.getFeatureMap(), "prep", 4, featureHash);
		l.add(c);
		c = new Nonterminal("nounphrase_cut");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		c.setFeature("copula", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 5, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// compl_adj(rel:A, embv:B, whin:C, whout:D)=>[more, 'ADJ_TR'], nounphrase_cut(rel:minus, copula:minus, embv:B, whin:C, whout:E), [than], nounphrase_cut(rel:A, copula:minus, embv:B, whin:E, whout:D)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("compl_adj");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Terminal("more");
		l.add(c);
		c = new Terminal("ADJ_TR");
		l.add(c);
		c = new Nonterminal("nounphrase_cut");
		c.setFeature("rel", new StringRef("minus"));
		c.setFeature("copula", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 4, featureHash);
		l.add(c);
		c = new Terminal("than");
		l.add(c);
		c = new Nonterminal("nounphrase_cut");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		c.setFeature("copula", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 4, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// compl_adj(rel:A, embv:B, whin:C, whout:D)=>['ADJ_TR_COMP'], nounphrase_cut(rel:minus, copula:minus, embv:B, whin:C, whout:E), [than], nounphrase_cut(rel:A, copula:minus, embv:B, whin:E, whout:D)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("compl_adj");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Terminal("ADJ_TR_COMP");
		l.add(c);
		c = new Nonterminal("nounphrase_cut");
		c.setFeature("rel", new StringRef("minus"));
		c.setFeature("copula", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 4, featureHash);
		l.add(c);
		c = new Terminal("than");
		l.add(c);
		c = new Nonterminal("nounphrase_cut");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		c.setFeature("copula", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 4, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// compl_adj(rel:A, embv:B, whin:C, whout:D)=>[more, 'ADJ_TR'(prep:E)], nounphrase_cut(rel:minus, copula:minus, embv:B, whin:C, whout:F), [than, 'ADJ_TR_PREP'(prep:E)], nounphrase_cut(rel:A, copula:minus, embv:B, whin:F, whout:D)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("compl_adj");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Terminal("more");
		l.add(c);
		c = new Terminal("ADJ_TR");
		setFeature(c.getFeatureMap(), "prep", 4, featureHash);
		l.add(c);
		c = new Nonterminal("nounphrase_cut");
		c.setFeature("rel", new StringRef("minus"));
		c.setFeature("copula", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 5, featureHash);
		l.add(c);
		c = new Terminal("than");
		l.add(c);
		c = new Terminal("ADJ_TR_PREP");
		setFeature(c.getFeatureMap(), "prep", 4, featureHash);
		l.add(c);
		c = new Nonterminal("nounphrase_cut");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		c.setFeature("copula", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 5, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// compl_adj(rel:A, embv:B, whin:C, whout:D)=>['ADJ_TR_COMP'(prep:E)], nounphrase_cut(rel:minus, copula:minus, embv:B, whin:C, whout:F), [than, 'ADJ_TR_PREP'(prep:E)], nounphrase_cut(rel:A, copula:minus, embv:B, whin:F, whout:D)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("compl_adj");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Terminal("ADJ_TR_COMP");
		setFeature(c.getFeatureMap(), "prep", 4, featureHash);
		l.add(c);
		c = new Nonterminal("nounphrase_cut");
		c.setFeature("rel", new StringRef("minus"));
		c.setFeature("copula", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 5, featureHash);
		l.add(c);
		c = new Terminal("than");
		l.add(c);
		c = new Terminal("ADJ_TR_PREP");
		setFeature(c.getFeatureMap(), "prep", 4, featureHash);
		l.add(c);
		c = new Nonterminal("nounphrase_cut");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		c.setFeature("copula", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "embv", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 5, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// v_modifiers(whin:A, whout:A)=>[]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("v_modifiers");
		setFeature(c.getFeatureMap(), "whin", 0, featureHash);
		setFeature(c.getFeatureMap(), "whout", 0, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// v_modifiers(rel:A, embv:minus, copula:B, whin:C, whout:D)=>adv_coord(copula:B), v_modifiers_x(rel:A, copula:B, whin:C, whout:D)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("v_modifiers");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		c.setFeature("embv", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "copula", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Nonterminal("adv_coord");
		setFeature(c.getFeatureMap(), "copula", 1, featureHash);
		l.add(c);
		c = new Nonterminal("v_modifiers_x");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "copula", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// v_modifiers(rel:A, embv:minus, copula:B, whin:C, whout:D)=>pp(rel:A, embv:E, whin:C, whout:F), v_modifiers(rel:A, embv:E, copula:B, whin:F, whout:D)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("v_modifiers");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		c.setFeature("embv", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "copula", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Nonterminal("pp");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "embv", 4, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 5, featureHash);
		l.add(c);
		c = new Nonterminal("v_modifiers");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "embv", 4, featureHash);
		setFeature(c.getFeatureMap(), "copula", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 5, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// v_modifiers_x(whin:A, whout:A)=>[]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("v_modifiers_x");
		setFeature(c.getFeatureMap(), "whin", 0, featureHash);
		setFeature(c.getFeatureMap(), "whout", 0, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// v_modifiers_x(rel:A, copula:B, whin:C, whout:D)=>pp(rel:A, embv:E, whin:C, whout:F), v_modifiers(rel:A, embv:E, copula:B, whin:F, whout:D)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("v_modifiers_x");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "copula", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Nonterminal("pp");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "embv", 4, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 5, featureHash);
		l.add(c);
		c = new Nonterminal("v_modifiers");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "embv", 4, featureHash);
		setFeature(c.getFeatureMap(), "copula", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 5, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// pp(rel:A, whin:B, whout:C)=>['PREP'], nounphrase_cut(rel:A, whin:B, whout:C)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("pp");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 2, featureHash);
		l.add(c);
		c = new Terminal("PREP");
		l.add(c);
		c = new Nonterminal("nounphrase_cut");
		setFeature(c.getFeatureMap(), "rel", 0, featureHash);
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 2, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// adv_coord(copula:minus)=>adv
		l.clear();
		featureHash.clear();
		c = new Nonterminal("adv_coord");
		c.setFeature("copula", new StringRef("minus"));
		l.add(c);
		c = new Nonterminal("adv");
		l.add(c);
		addRule(new Rule(l, true));
		
		// adv_coord(copula:minus)=>adv, [and], adv_coord
		l.clear();
		featureHash.clear();
		c = new Nonterminal("adv_coord");
		c.setFeature("copula", new StringRef("minus"));
		l.add(c);
		c = new Nonterminal("adv");
		l.add(c);
		c = new Terminal("and");
		l.add(c);
		c = new Nonterminal("adv_coord");
		l.add(c);
		addRule(new Rule(l, true));
		
		// adv=>['ADV']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("adv");
		l.add(c);
		c = new Terminal("ADV");
		l.add(c);
		addRule(new Rule(l, true));
		
		// adv=>[more, 'ADV']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("adv");
		l.add(c);
		c = new Terminal("more");
		l.add(c);
		c = new Terminal("ADV");
		l.add(c);
		addRule(new Rule(l, true));
		
		// adv=>['ADV_COMP']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("adv");
		l.add(c);
		c = new Terminal("ADV_COMP");
		l.add(c);
		addRule(new Rule(l, true));
		
		// adv=>[most, 'ADV']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("adv");
		l.add(c);
		c = new Terminal("most");
		l.add(c);
		c = new Terminal("ADV");
		l.add(c);
		addRule(new Rule(l, true));
		
		// adv=>['ADV_SUP']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("adv");
		l.add(c);
		c = new Terminal("ADV_SUP");
		l.add(c);
		addRule(new Rule(l, true));
		
		// exist_anon(human:minus)=>[something]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("exist_anon");
		c.setFeature("human", new StringRef("minus"));
		l.add(c);
		c = new Terminal("something");
		l.add(c);
		addRule(new Rule(l, true));
		
		// exist_anon(human:plus)=>[somebody]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("exist_anon");
		c.setFeature("human", new StringRef("plus"));
		l.add(c);
		c = new Terminal("somebody");
		l.add(c);
		addRule(new Rule(l, true));
		
		// univ_anon(human:minus)=>[everything]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("univ_anon");
		c.setFeature("human", new StringRef("minus"));
		l.add(c);
		c = new Terminal("everything");
		l.add(c);
		addRule(new Rule(l, true));
		
		// univ_anon(human:plus)=>[everybody]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("univ_anon");
		c.setFeature("human", new StringRef("plus"));
		l.add(c);
		c = new Terminal("everybody");
		l.add(c);
		addRule(new Rule(l, true));
		
		// neg_anon(human:minus)=>[nothing]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("neg_anon");
		c.setFeature("human", new StringRef("minus"));
		l.add(c);
		c = new Terminal("nothing");
		l.add(c);
		addRule(new Rule(l, true));
		
		// neg_anon(human:plus)=>[nobody]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("neg_anon");
		c.setFeature("human", new StringRef("plus"));
		l.add(c);
		c = new Terminal("nobody");
		l.add(c);
		addRule(new Rule(l, true));
		
		// num_quant=>['at least']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("num_quant");
		l.add(c);
		c = new Terminal("at least");
		l.add(c);
		addRule(new Rule(l, true));
		
		// num_quant=>['at most']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("num_quant");
		l.add(c);
		c = new Terminal("at most");
		l.add(c);
		addRule(new Rule(l, true));
		
		// num_quant=>['less than']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("num_quant");
		l.add(c);
		c = new Terminal("less than");
		l.add(c);
		addRule(new Rule(l, true));
		
		// num_quant=>['more than']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("num_quant");
		l.add(c);
		c = new Terminal("more than");
		l.add(c);
		addRule(new Rule(l, true));
		
		// num_quant=>[exactly]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("num_quant");
		l.add(c);
		c = new Terminal("exactly");
		l.add(c);
		addRule(new Rule(l, true));
		
		// propername(human:A)=>['PN_SG'(human:A)]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("propername");
		setFeature(c.getFeatureMap(), "human", 0, featureHash);
		l.add(c);
		c = new Terminal("PN_SG");
		setFeature(c.getFeatureMap(), "human", 0, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// propername(human:A)=>['PNDEF_SG'(human:A)]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("propername");
		setFeature(c.getFeatureMap(), "human", 0, featureHash);
		l.add(c);
		c = new Terminal("PNDEF_SG");
		setFeature(c.getFeatureMap(), "human", 0, featureHash);
		l.add(c);
		addRule(new Rule(l, true));

	}
	
	private void setFeature(FeatureMap fm, String featureName, int varID, HashMap<Integer, StringRef> featureHash) {
		if (featureHash.get(varID) == null) {
			StringRef stringRef = new StringRef();
			fm.setFeature(featureName, stringRef);
			featureHash.put(varID, stringRef);
		} else {
			fm.setFeature(featureName, featureHash.get(varID));
		}
	}
	
}