% This file is part of the Attempto Java Packages.
% Copyright 2008-2009, Attempto Group, University of Zurich (see http://attempto.ifi.uzh.ch).
%
% The Attempto Java Packages is free software: you can redistribute it and/or modify it under the
% terms of the GNU Lesser General Public License as published by the Free Software Foundation,
% either version 3 of the License, or (at your option) any later version.
%
% The Attempto Java Packages is distributed in the hope that it will be useful, but WITHOUT ANY
% WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
% PURPOSE. See the GNU Lesser General Public License for more details.
%
% You should have received a copy of the GNU Lesser General Public License along with the Attempto
% Java Packages. If not, see http://www.gnu.org/licenses/.

%===================================================================================================
% This is the grammar used by the ACE Editor in the Codeco format. It covers a subset of ACE.
%
% Author: Tobias Kuhn
%===================================================================================================

% ---
% these rules are only for regression testing:
test => declaration, fill.
test => question, fill.
fill => [].
fill => ['-'], fill.
% ---

text =>
	[].

text =>
	declaration,
	text.

text =>
	question.

declaration =>
	sentence,
	['.'].

question =>
	simple_sentence_2(whin:minus, whout:plus),
	['?'].

sentence =>
	sentence_coord_1.

sentence ~>
	['for every'],
	noun_constr,
	sentence_coord_1.

sentence ~>
	[if],
	sentence_coord_1,
	[then],
	sentence_coord_1.

sentence_coord_1 =>
	sentence_coord_2.

sentence_coord_1 ~>
	sentence_coord_2,
	[or],
	sentence_coord_1.

sentence_coord_2 =>
	simple_sentence.

sentence_coord_2 =>
	simple_sentence,
	[and],
	sentence_coord_2.

simple_sentence ~>
	['it is false that'],
	simple_sentence_2(whin:minus, whout:minus).

simple_sentence =>
	['there is'],
	nounphrase(exist:plus, def:minus, pl:minus, whin:minus, whout:minus).

simple_sentence =>
	['there is'],
	nounphrase(exist:plus, def:minus, pl:minus, whin:minus, whout:minus),
	['such that'],
	simple_sentence.

simple_sentence =>
	['there are'],
	nounphrase(exist:plus, def:minus, pl:plus, whin:minus, whout:minus).

simple_sentence =>
	simple_sentence_2(whin:minus, whout:minus).

simple_sentence_2(whin:WhIn, whout:WhOut) =>
	nounphrase(exist:plus, pl:PL, whin:WhIn, whout:WhTemp),
	verbphrase_coord_1(pl:PL, whin:WhTemp, whout:WhOut).

simple_sentence_2(whin:WhIn, whout:WhOut) ~>
	nounphrase(exist:minus, whin:WhIn, whout:WhTemp),
	verbphrase_coord_1(pl:minus, whin:WhTemp, whout:WhOut).

verbphrase_coord_1(pl:PL, whin:WhIn, whout:WhOut) =>
	verbphrase_coord_2(pl:PL, whin:WhIn, whout:WhOut).

verbphrase_coord_1(pl:PL, whin:WhIn, whout:WhOut) ~>
	verbphrase_coord_2(pl:PL, whin:WhIn, whout:WhTemp),
	[or],
	verbphrase_coord_1(pl:PL, whin:WhTemp, whout:WhOut).

verbphrase_coord_2(pl:PL, whin:WhIn, whout:WhOut) =>
	vp_cut(pl:PL, whin:WhIn, whout:WhOut).

verbphrase_coord_2(pl:PL, whin:WhIn, whout:WhOut) =>
	vp_cut(pl:PL, whin:WhIn, whout:WhTemp),
	[and],
	verbphrase_coord_2(pl:PL, whin:WhTemp, whout:WhOut).

vp_cut(rel:R, pl:PL, whin:WhIn, whout:WhOut) =>
	vp(exists:plus, rel:R, pl:PL, whin:WhIn, whout:WhOut).

vp_cut(rel:R, pl:PL, whin:WhIn, whout:WhOut) ~>
	vp(exists:minus, rel:R, pl:PL, whin:WhIn, whout:WhOut).

vp(exists:Neg, rel:R, pl:PL, whin:WhIn, whout:WhOut) =>
	auxiliary(be:Be, exists:Neg, pl:PL),
	vbar(be:Be, exists:Neg, pl:PL, rel:R, vform:inf, embv:EmbV, copula:Cop, whin:WhIn, whout:WhTemp),
	v_modifiers(embv:EmbV, copula:Cop, whin:WhTemp, whout:WhOut).

vp(exists:plus, rel:R, pl:PL, whin:WhIn, whout:WhOut) =>
	vbar(be:minus, exists:plus, pl:PL, rel:R, vform:fin, embv:EmbV, copula:Cop, whin:WhIn, whout:WhTemp),
	v_modifiers(embv:EmbV, copula:Cop, whin:WhTemp, whout:WhOut).

vbar(be:minus, exists:Neg, pl:PL, vform:VF, copula:minus, whin:Wh, whout:Wh) =>
	verb(vsubcat:itr, be:minus, pl:PL, exists:Neg, vform:VF).

vbar(be:minus, exists:Neg, rel:R, pl:PL, vform:VF, embv:EmbV, copula:minus, whin:WhIn, whout:WhOut) =>
	verb(vsubcat:tr, be:minus, pl:PL, exists:Neg, vform:VF),
	nounphrase_cut(rel:R, vsubcat:tr, embv:EmbV, whin:WhIn, whout:WhOut).

vbar(be:plus, rel:R, embv:EmbV, copula:minus, whin:WhIn, whout:WhOut) =>
	verb(vsubcat:tr, be:plus, pl:PL, exists:Neg, vform:VF),
	[by],
	nounphrase_cut(rel:R, copula:minus, embv:EmbV, whin:WhIn, whout:WhOut).

vbar(be:plus, rel:R, embv:EmbV, copula:plus, whin:WhIn, whout:WhOut) =>
	nounphrase_cut(of:plus, rel:R, pl:minus, copula:plus, embv:EmbV, whin:WhIn, whout:WhOut).

vbar(be:plus, rel:R, pl:minus, embv:EmbV, copula:plus, whin:WhIn, whout:WhOut) =>
	nounphrase_cut(of:minus, rel:R, pl:minus, copula:plus, embv:EmbV, whin:WhIn, whout:WhOut).

vbar(be:plus, rel:R, copula:plus, whin:Wh, whout:Wh) =>
	adj_coord.

vbar(be:plus, rel:R, embv:EmbV, copula:plus, whin:WhIn, whout:WhOut) =>
	compl_adj(rel:R, embv:EmbV, whin:WhIn, whout:WhOut).

nounphrase_cut(exist:plus, rel:R, of:Of, def:Def, pl:PL, copula:C, embv:EmbV, whin:WhIn, whout:WhOut) =>
	nounphrase(exist:plus, rel:R, of:Of, def:Def, pl:PL, copula:C, embv:EmbV, whin:WhIn, whout:WhOut).

nounphrase_cut(exist:minus, rel:R, of:Of, def:Def, pl:PL, copula:C, embv:EmbV, whin:WhIn, whout:WhOut) ~>
	nounphrase(exist:minus, rel:R, of:Of, def:Def, pl:PL, copula:C, embv:EmbV, whin:WhIn, whout:WhOut).

nounphrase(exist:plus, rel:R, of:minus, def:plus, pl:minus, embv:EmbV, whin:WhIn, whout:WhOut) =>
	propername(human:H),
	rel_phrase(rel:R, embv:EmbV, human:H, whin:WhIn, whout:WhOut).

nounphrase(exist:plus, of:minus, def:plus, pl:minus, whin:Wh, whout:Wh) =>
	var_ante.

nounphrase(exist:plus, of:minus, def:plus, pl:minus, whin:Wh, whout:Wh) ~>
	['DEF_NOUN_SG'(noun:Noun), 'REF'(text:Var)],
	<<<(type:noun, hasvar:plus, noun:Noun, var:Var).

nounphrase(exist:plus, of:minus, def:plus, pl:minus, whin:Wh, whout:Wh) ~>
	['DEF_NOUN_SG'(noun:Noun)],
	<<<(type:noun, noun:Noun).

nounphrase(exist:plus, of:minus, def:plus, pl:minus, whin:Wh, whout:Wh) ~>
	['REF'(text:Var)],
	<<<(hasvar:plus, var:Var).

nounphrase(exist:plus, rel:R, of:O, pl:minus, embv:EmbV, whin:WhIn, whout:WhOut) =>
	[a],
	noun_constr(rel:R, of:O, embv:EmbV, whin:WhIn, whout:WhOut).

nounphrase(exist:plus, rel:R, of:O, pl:minus, embv:EmbV, whin:WhIn, whout:WhOut) =>
	[an],
	noun_constr(rel:R, of:O, embv:EmbV, whin:WhIn, whout:WhOut).

nounphrase(exist:plus, rel:R, of:minus, pl:minus, embv:EmbV, whin:WhIn, whout:WhOut) =>
	exist_anon(human:H),
	var_ante,
 	rel_phrase(rel:R, embv:EmbV, human:H, whin:WhIn, whout:WhOut).

nounphrase(exist:plus, rel:R, of:minus, pl:minus, embv:EmbV, whin:WhIn, whout:WhOut) =>
	exist_anon(human:H),
	rel_phrase(rel:R, embv:EmbV, human:H, whin:WhIn, whout:WhOut).

nounphrase(exist:plus, of:minus, pl:plus, copula:minus, whin:Wh, whout:Wh) =>
	num_quant,
	['NUM'],
	opt_adj_coord,
	['NOUN_PL'].

nounphrase(exist:plus, of:minus, pl:minus, copula:minus, whin:Wh, whout:Wh) =>
	num_quant,
	[1],
	opt_adj_coord,
	['NOUN_SG'].

nounphrase(exist:plus, of:minus, pl:minus, whout:plus) =>
	[what].

nounphrase(exist:plus, of:minus, pl:minus, whout:plus) =>
	[who].

nounphrase(exist:plus, rel:R, of:O, embv:EmbV, pl:minus, whout:plus) =>
	[which],
	noun_constr(rel:R, of:O, embv:EmbV, whin:plus, whout:plus).

nounphrase(exist:plus, of:minus, pl:plus, whout:plus) =>
	[which],
	opt_adj_coord,
	['NOUN_PL'].

nounphrase(exist:minus, rel:R, of:O, pl:minus, embv:EmbV, whin:WhIn, whout:WhOut) =>
	[every],
	noun_constr(rel:R, of:O, embv:EmbV, whin:WhIn, whout:WhOut).

nounphrase(exist:minus, rel:R, of:minus, pl:minus, embv:EmbV, whin:WhIn, whout:WhOut) =>
	univ_anon(human:H),
	var_ante,
	rel_phrase(rel:R, embv:EmbV, human:H, whin:WhIn, whout:WhOut).

nounphrase(exist:minus, rel:R, of:minus, pl:minus, embv:EmbV, whin:WhIn, whout:WhOut) =>
	univ_anon(human:H),
	rel_phrase(rel:R, embv:EmbV, human:H, whin:WhIn, whout:WhOut).

nounphrase(exist:minus, rel:R, of:O, pl:minus, embv:EmbV, whin:WhIn, whout:WhOut) =>
	[no],
	noun_constr(rel:R, of:O, embv:EmbV, whin:WhIn, whout:WhOut).

nounphrase(exist:minus, rel:R, of:minus, pl:minus, embv:EmbV, whin:WhIn, whout:WhOut) =>
	neg_anon(human:H),
	var_ante,
	rel_phrase(rel:R, embv:EmbV, human:H, whin:WhIn, whout:WhOut).

nounphrase(exist:minus, rel:R, of:minus, pl:minus, embv:EmbV, whin:WhIn, whout:WhOut) =>
	neg_anon(human:H),
	rel_phrase(rel:R, embv:EmbV, human:H, whin:WhIn, whout:WhOut).

noun_constr(rel:R, of:minus, embv:EmbV, whin:WhIn, whout:WhOut) =>
	opt_adj_coord,
	noun_ante(human:H),
	rel_phrase(rel:R, embv:EmbV, human:H, whin:WhIn, whout:WhOut).

noun_constr(rel:R, of:plus, embv:EmbV, whin:WhIn, whout:WhOut) =>
	opt_adj_coord,
	['NOUN_SG', of],
	nounphrase_cut(rel:R, embv:EmbV, whin:WhIn, whout:WhOut).

noun_ante(human:H) =>
	['NOUN_SG'(human:H, text:Noun, id:ID)], newvar(var:Var),
	>>>(type:noun, hasvar:plus, noun:Noun, var:Var, id:ID).

noun_ante(human:H) =>
	['NOUN_SG'(human:H, text:Noun, id:ID)],
	>>>(type:noun, hasvar:minus, noun:Noun, id:ID).

var_ante =>
	newvar(var:Var, id:ID),
	>>>(type:var, hasvar:plus, var:Var, id:ID).

newvar(var:Var) =>
	['VAR'(text:Var)],
	</<(hasvar:plus, var:Var).

auxiliary(be:minus, exists:minus, pl:minus) =>
	['has to'].

auxiliary(be:minus, exists:minus, pl:plus) =>
	['have to'].

auxiliary(be:plus, exists:plus, pl:minus) =>
	[is].

auxiliary(be:plus, exists:minus, pl:minus) =>
	['is not'].
	
auxiliary(be:plus, exists:minus, pl:minus) =>
	[is, not].

auxiliary(be:plus, exists:plus, pl:plus) =>
	[are].

auxiliary(be:plus, exists:minus, pl:plus) =>
	['are not'].
	
auxiliary(be:plus, exists:minus, pl:plus) =>
	[are, not].

auxiliary(be:minus, exists:minus, pl:minus) =>
	['does not'].

auxiliary(be:minus, exists:minus, pl:plus) =>
	['do not'].
	
auxiliary(be:minus, exists:minus) =>
	[can].
	
auxiliary(be:minus, exists:minus) =>
	[should].
	
auxiliary(be:minus, exists:minus) =>
	[must].

auxiliary(be:plus, exists:minus) =>
	[can, be].

auxiliary(be:plus, exists:minus) =>
	[should, be].

auxiliary(be:plus, exists:minus) =>
	[must, be].

auxiliary(be:plus, exists:minus, pl:minus) =>
	['has to', be].

auxiliary(be:plus, exists:minus, pl:plus) =>
	['have to', be].
	
auxiliary(be:plus, exists:minus) =>
	[cannot, be].
	
auxiliary(be:plus, exists:minus) =>
	[can, not, be].
	
auxiliary(be:plus, exists:minus) =>
	[should, not, be].

auxiliary(be:plus, exists:minus, pl:minus) =>
	['does not', 'have to', be].

auxiliary(be:plus, exists:minus, pl:plus) =>
	['do not', 'have to', be].

auxiliary(be:minus, exists:minus, pl:minus) =>
	[cannot].

auxiliary(be:minus, exists:minus, pl:minus) =>
	[can, not].

auxiliary(be:minus, exists:minus, pl:minus) =>
	[should, not].

auxiliary(be:minus, exists:minus, pl:minus) =>
	['does not', 'have to'].

auxiliary(be:minus, exists:minus, pl:plus) =>
	['do not', 'have to'].

verb(be:minus, vsubcat:itr, pl:minus, vform:fin) =>
	['IV_FINSG'].

verb(be:minus, vsubcat:itr, pl:plus, vform:fin) =>
	['IV_INFPL'].

verb(be:minus, vsubcat:itr, vform:inf) =>
	['IV_INFPL'].

verb(be:minus, vsubcat:tr, pl:minus, vform:fin) =>
	['TV_FINSG'].

verb(be:minus, vsubcat:tr, pl:plus, vform:fin) =>
	['TV_INFPL'].

verb(be:minus, vsubcat:tr, vform:inf) =>
	['TV_INFPL'].

verb(be:plus, vsubcat:tr) =>
	['TV_PP'].

rel_phrase(whin:Wh, whout:Wh) =>
	[].

rel_phrase(rel:plus, embv:plus, human:H, whin:WhIn, whout:WhOut) =>
	rel_pron(human:H, relpron:RP),
	rel_phrase_1(human:H, relpron:RP, whin:WhIn, whout:WhOut).

rel_phrase_1(human:H, relpron:RP, whin:WhIn, whout:WhOut) ~>
	rel_phrase_2(human:H, rel:minus, relpron:RP, whin:WhIn, whout:WhTemp),
	or_rel_pron(human:H, relpron:RP),
	rel_phrase_1(human:H, relpron:RP, whin:WhTemp, whout:WhOut).

rel_phrase_1(human:H, relpron:RP, whin:WhIn, whout:WhOut) =>
	rel_phrase_2(human:H, relpron:RP, whin:WhIn, whout:WhOut).

rel_phrase_2(rel:R, relpron:RP, human:H, whin:WhIn, whout:WhOut) =>
	vp_cut(rel:minus, pl:minus, whin:WhIn, whout:WhTemp),
	and_rel_pron(human:H, relpron:RP),
	rel_phrase_2(rel:R, relpron:RP, human:H, whin:WhTemp, whout:WhOut).

rel_phrase_2(rel:R, whin:WhIn, whout:WhOut) =>
	vp_cut(rel:R, pl:minus, whin:WhIn, whout:WhOut).

rel_phrase_2(rel:R, whin:WhIn, whout:WhOut) =>
	nounphrase_cut(rel:minus, copula:minus, pl:PL, embv:EmbV, whin:WhIn, whout:WhTemp),
	auxiliary(be:minus, exists:Neg, pl:PL),
	verb(vsubcat:tr, be:minus, exists:Neg, pl:PL, vform:inf),
	v_modifiers(rel:R, embv:EmbV, copula:minus, whin:WhTemp, whout:WhOut).

rel_phrase_2(rel:R, whin:WhIn, whout:WhOut) =>
	nounphrase_cut(rel:minus, copula:minus, pl:PL, embv:EmbV, whin:WhIn, whout:WhTemp),
	verb(vsubcat:tr, be:minus, exists:plus, pl:PL, vform:fin),
	v_modifiers(rel:R, embv:EmbV, copula:minus, whin:WhTemp, whout:WhOut).

rel_pron(relpron:that) =>
	[that].

rel_pron(human:plus, relpron:who) =>
	[who].

rel_pron(human:minus, relpron:which) =>
	[which].

or_rel_pron(human:H, relpron:RP) =>
	[or],
	rel_pron(human:H, relpron:RP).

or_rel_pron(relpron:that) =>
	['or that'].

or_rel_pron(human:plus, relpron:who) =>
	['or who'].

or_rel_pron(human:minus, relpron:which) =>
	['or which'].

and_rel_pron(human:H, relpron:RP) =>
	[and],
	rel_pron(human:H, relpron:RP).

and_rel_pron(relpron:that) =>
	['and that'].

and_rel_pron(human:plus, relpron:who) =>
	['and who'].

and_rel_pron(human:minus, relpron:which) =>
	['and which'].

opt_adj_coord =>
	[].

opt_adj_coord =>
	adj_coord.

adj_coord =>
	adj_itr.

adj_coord =>
	adj_itr,
	[and],
	adj_coord.

adj_itr =>
	['ADJ_ITR'].

adj_itr =>
	[more, 'ADJ_ITR'].

adj_itr =>
	['ADJ_ITR_COMP'].

adj_itr =>
	[most, 'ADJ_ITR'].

adj_itr =>
	['ADJ_ITR_SUP'].

compl_adj(rel:R, embv:EmbV, whin:WhIn, whout:WhOut) =>
	[as, 'ADJ_ITR', as],
	nounphrase_cut(rel:R, copula:minus, embv:EmbV, whin:WhIn, whout:WhOut).

compl_adj(rel:R, embv:EmbV, whin:WhIn, whout:WhOut) =>
	['ADJ_ITR_COMP', than],
	nounphrase_cut(rel:R, copula:minus, embv:EmbV, whin:WhIn, whout:WhOut).

compl_adj(rel:R, embv:EmbV, whin:WhIn, whout:WhOut) =>
	[more, 'ADJ_ITR', than],
	nounphrase_cut(rel:R, copula:minus, embv:EmbV, whin:WhIn, whout:WhOut).

compl_adj(rel:R, embv:EmbV, whin:WhIn, whout:WhOut) =>
	['ADJ_TR'],
	nounphrase_cut(rel:R, copula:minus, embv:EmbV, whin:WhIn, whout:WhOut).

compl_adj(rel:R, embv:EmbV, whin:WhIn, whout:WhOut) =>
	[more, 'ADJ_TR'],
	nounphrase_cut(rel:R, copula:minus, embv:EmbV, whin:WhIn, whout:Out).

compl_adj(rel:R, embv:EmbV, whin:WhIn, whout:WhOut) =>
	[most, 'ADJ_TR'],
	nounphrase_cut(rel:R, copula:minus, embv:EmbV, whin:WhIn, whout:Out).

compl_adj(rel:R, embv:EmbV, whin:WhIn, whout:WhOut) =>
	[as, 'ADJ_TR'],
	nounphrase_cut(rel:minus, copula:minus, embv:EmbV, whin:WhIn, whout:WhTemp),
	[as],
	nounphrase_cut(rel:R, copula:minus, embv:EmbV, whin:WhTemp, whout:WhOut).

compl_adj(rel:R, embv:EmbV, whin:WhIn, whout:WhOut) =>
	[as, 'ADJ_TR'(prep:P)],
	nounphrase_cut(rel:minus, copula:minus, embv:EmbV, whin:WhIn, whout:WhTemp),
	[as, 'ADJ_TR_PREP'(prep:P)],
	nounphrase_cut(rel:R, copula:minus, embv:EmbV, whin:WhTemp, whout:WhOut).

compl_adj(rel:R, embv:EmbV, whin:WhIn, whout:WhOut) =>
	[more, 'ADJ_TR'],
	nounphrase_cut(rel:minus, copula:minus, embv:EmbV, whin:WhIn, whout:WhTemp),
	[than],
	nounphrase_cut(rel:R, copula:minus, embv:EmbV, whin:WhTemp, whout:WhOut).

compl_adj(rel:R, embv:EmbV, whin:WhIn, whout:WhOut) =>
	['ADJ_TR_COMP'],
	nounphrase_cut(rel:minus, copula:minus, embv:EmbV, whin:WhIn, whout:WhTemp),
	[than],
	nounphrase_cut(rel:R, copula:minus, embv:EmbV, whin:WhTemp, whout:WhOut).

compl_adj(rel:R, embv:EmbV, whin:WhIn, whout:WhOut) =>
	[more, 'ADJ_TR'(prep:P)],
	nounphrase_cut(rel:minus, copula:minus, embv:EmbV, whin:WhIn, whout:WhTemp),
	[than, 'ADJ_TR_PREP'(prep:P)],
	nounphrase_cut(rel:R, copula:minus, embv:EmbV, whin:WhTemp, whout:WhOut).

compl_adj(rel:R, embv:EmbV, whin:WhIn, whout:WhOut) =>
	['ADJ_TR_COMP'(prep:P)],
	nounphrase_cut(rel:minus, copula:minus, embv:EmbV, whin:WhIn, whout:WhTemp),
	[than, 'ADJ_TR_PREP'(prep:P)],
	nounphrase_cut(rel:R, copula:minus, embv:EmbV, whin:WhTemp, whout:WhOut).

v_modifiers(whin:Wh, whout:Wh) =>
	[].

v_modifiers(rel:R, embv:minus, copula:Cop, whin:WhIn, whout:WhOut) =>
	adv_coord(copula:Cop),
	v_modifiers_x(rel:R, copula:Cop, whin:WhIn, whout:WhOut).

v_modifiers(rel:R, embv:minus, copula:Cop, whin:WhIn, whout:WhOut) =>
	pp(rel:R, embv:EmbV, whin:WhIn, whout:WhTemp),
	v_modifiers(rel:R, embv:EmbV, copula:Cop, whin:WhTemp, whout:WhOut).

v_modifiers_x(whin:Wh, whout:Wh) =>
	[].

v_modifiers_x(rel:R, copula:Cop, whin:WhIn, whout:WhOut) =>
	pp(rel:R, embv:EmbV, whin:WhIn, whout:WhTemp),
	v_modifiers(rel:R, embv:EmbV, copula:Cop, whin:WhTemp, whout:WhOut).

pp(rel:R, whin:WhIn, whout:WhOut) =>
	['PREP'],
	nounphrase_cut(rel:R, whin:WhIn, whout:WhOut).

adv_coord(copula:minus) =>
	adv.

adv_coord(copula:minus) =>
	adv,
	[and],
	adv_coord.

adv =>
	['ADV'].

adv =>
	[more, 'ADV'].

adv =>
	['ADV_COMP'].

adv =>
	[most, 'ADV'].

adv =>
	['ADV_SUP'].

exist_anon(human:minus) =>
	[something].

exist_anon(human:plus) =>
	[somebody].

univ_anon(human:minus) =>
	[everything].

univ_anon(human:plus) =>
	[everybody].

neg_anon(human:minus) =>
	[nothing].

neg_anon(human:plus) =>
	[nobody].

num_quant =>
	['at least'].

num_quant =>
	['at most'].

num_quant =>
	['less than'].

num_quant =>
	['more than'].

num_quant =>
	['exactly'].

propername(human:H) =>
	['PN_SG'(human:H)].

propername(human:H) =>
	['PNDEF_SG'(human:H)].
