package ch.uzh.ifi.attempto.acewiki.core.grammar;

import java.util.ArrayList;
import java.util.HashMap;

import ch.uzh.ifi.attempto.chartparser.Nonterminal;
import ch.uzh.ifi.attempto.chartparser.Rule;
import ch.uzh.ifi.attempto.chartparser.StringRef;
import ch.uzh.ifi.attempto.chartparser.Terminal;
import ch.uzh.ifi.attempto.chartparser.Category;
import ch.uzh.ifi.attempto.chartparser.FeatureMap;

/**
 * This grammar class is automatically generated by the SWI Prolog program "generate_java.pl".
 */
@SuppressWarnings("all")
public class StandardGrammar extends ch.uzh.ifi.attempto.chartparser.Grammar {
	
	/**
	 * Creates a new grammar object.
	 */
	public StandardGrammar() {
		super("text");
		ArrayList<Category> l = new ArrayList<Category>();
		Category c;
		HashMap<Integer, StringRef> featureHash = new HashMap<Integer, StringRef>();
		
		// test=>textelement, fill
		l.clear();
		featureHash.clear();
		c = new Nonterminal("test");
		l.add(c);
		c = new Nonterminal("textelement");
		l.add(c);
		c = new Nonterminal("fill");
		l.add(c);
		addRule(new Rule(l, true));
		
		// fill=>[]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("fill");
		l.add(c);
		addRule(new Rule(l, true));
		
		// fill=>[-], fill
		l.clear();
		featureHash.clear();
		c = new Nonterminal("fill");
		l.add(c);
		c = new Terminal("-");
		l.add(c);
		c = new Nonterminal("fill");
		l.add(c);
		addRule(new Rule(l, true));
		
		// text~>[]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("text");
		l.add(c);
		addRule(new Rule(l, false));
		
		// text~>textelement, text
		l.clear();
		featureHash.clear();
		c = new Nonterminal("text");
		l.add(c);
		c = new Nonterminal("textelement");
		l.add(c);
		c = new Nonterminal("text");
		l.add(c);
		addRule(new Rule(l, false));
		
		// textelement~>declaration
		l.clear();
		featureHash.clear();
		c = new Nonterminal("textelement");
		l.add(c);
		c = new Nonterminal("declaration");
		l.add(c);
		addRule(new Rule(l, false));
		
		// textelement~>question
		l.clear();
		featureHash.clear();
		c = new Nonterminal("textelement");
		l.add(c);
		c = new Nonterminal("question");
		l.add(c);
		addRule(new Rule(l, false));
		
		// declaration~>sentence, ['.']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("declaration");
		l.add(c);
		c = new Nonterminal("sentence");
		l.add(c);
		c = new Terminal(".");
		l.add(c);
		addRule(new Rule(l, false));
		
		// question~>simple_sentence_2(whin:right, whout:left), [?]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("question");
		l.add(c);
		c = new Nonterminal("simple_sentence_2");
		c.setFeature("whin", new StringRef("right"));
		c.setFeature("whout", new StringRef("left"));
		l.add(c);
		c = new Terminal("?");
		l.add(c);
		addRule(new Rule(l, false));
		
		// sentence=>sentence_coord_1
		l.clear();
		featureHash.clear();
		c = new Nonterminal("sentence");
		l.add(c);
		c = new Nonterminal("sentence_coord_1");
		l.add(c);
		addRule(new Rule(l, true));
		
		// sentence~>['for every'], noun_constr, sentence_coord_1
		l.clear();
		featureHash.clear();
		c = new Nonterminal("sentence");
		l.add(c);
		c = new Terminal("for every");
		l.add(c);
		c = new Nonterminal("noun_constr");
		l.add(c);
		c = new Nonterminal("sentence_coord_1");
		l.add(c);
		addRule(new Rule(l, false));
		
		// sentence~>[if], sentence_coord_1, [then], sentence_coord_1
		l.clear();
		featureHash.clear();
		c = new Nonterminal("sentence");
		l.add(c);
		c = new Terminal("if");
		l.add(c);
		c = new Nonterminal("sentence_coord_1");
		l.add(c);
		c = new Terminal("then");
		l.add(c);
		c = new Nonterminal("sentence_coord_1");
		l.add(c);
		addRule(new Rule(l, false));
		
		// sentence_coord_1=>sentence_coord_2
		l.clear();
		featureHash.clear();
		c = new Nonterminal("sentence_coord_1");
		l.add(c);
		c = new Nonterminal("sentence_coord_2");
		l.add(c);
		addRule(new Rule(l, true));
		
		// sentence_coord_1~>sentence_coord_2, [or], sentence_coord_1
		l.clear();
		featureHash.clear();
		c = new Nonterminal("sentence_coord_1");
		l.add(c);
		c = new Nonterminal("sentence_coord_2");
		l.add(c);
		c = new Terminal("or");
		l.add(c);
		c = new Nonterminal("sentence_coord_1");
		l.add(c);
		addRule(new Rule(l, false));
		
		// sentence_coord_2=>simple_sentence
		l.clear();
		featureHash.clear();
		c = new Nonterminal("sentence_coord_2");
		l.add(c);
		c = new Nonterminal("simple_sentence");
		l.add(c);
		addRule(new Rule(l, true));
		
		// sentence_coord_2=>simple_sentence, [and], sentence_coord_2
		l.clear();
		featureHash.clear();
		c = new Nonterminal("sentence_coord_2");
		l.add(c);
		c = new Nonterminal("simple_sentence");
		l.add(c);
		c = new Terminal("and");
		l.add(c);
		c = new Nonterminal("sentence_coord_2");
		l.add(c);
		addRule(new Rule(l, true));
		
		// simple_sentence~>['it is false that'], simple_sentence_2(whin:minus, whout:minus)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("simple_sentence");
		l.add(c);
		c = new Terminal("it is false that");
		l.add(c);
		c = new Nonterminal("simple_sentence_2");
		c.setFeature("whin", new StringRef("minus"));
		c.setFeature("whout", new StringRef("minus"));
		l.add(c);
		addRule(new Rule(l, false));
		
		// simple_sentence=>['there is'], nounphrase(exist:plus, def:minus, pl:minus, verb:be, whin:minus, whout:minus)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("simple_sentence");
		l.add(c);
		c = new Terminal("there is");
		l.add(c);
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("plus"));
		c.setFeature("def", new StringRef("minus"));
		c.setFeature("pl", new StringRef("minus"));
		c.setFeature("verb", new StringRef("be"));
		c.setFeature("whin", new StringRef("minus"));
		c.setFeature("whout", new StringRef("minus"));
		l.add(c);
		addRule(new Rule(l, true));
		
		// simple_sentence=>['there is'], nounphrase(exist:plus, def:minus, pl:minus, verb:be, whin:minus, whout:minus), ['such that'], simple_sentence
		l.clear();
		featureHash.clear();
		c = new Nonterminal("simple_sentence");
		l.add(c);
		c = new Terminal("there is");
		l.add(c);
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("plus"));
		c.setFeature("def", new StringRef("minus"));
		c.setFeature("pl", new StringRef("minus"));
		c.setFeature("verb", new StringRef("be"));
		c.setFeature("whin", new StringRef("minus"));
		c.setFeature("whout", new StringRef("minus"));
		l.add(c);
		c = new Terminal("such that");
		l.add(c);
		c = new Nonterminal("simple_sentence");
		l.add(c);
		addRule(new Rule(l, true));
		
		// simple_sentence=>['there are'], nounphrase(exist:plus, def:minus, pl:plus, whin:minus, whout:minus)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("simple_sentence");
		l.add(c);
		c = new Terminal("there are");
		l.add(c);
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("plus"));
		c.setFeature("def", new StringRef("minus"));
		c.setFeature("pl", new StringRef("plus"));
		c.setFeature("whin", new StringRef("minus"));
		c.setFeature("whout", new StringRef("minus"));
		l.add(c);
		addRule(new Rule(l, true));
		
		// simple_sentence=>simple_sentence_2(whin:minus, whout:minus)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("simple_sentence");
		l.add(c);
		c = new Nonterminal("simple_sentence_2");
		c.setFeature("whin", new StringRef("minus"));
		c.setFeature("whout", new StringRef("minus"));
		l.add(c);
		addRule(new Rule(l, true));
		
		// simple_sentence_2(whin:A, whout:B)=>nounphrase(exist:plus, pl:C, whin:A, whout:D), verbphrase_coord_1(pl:C, whin:D, whout:B)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("simple_sentence_2");
		setFeature(c.getFeatureMap(), "whin", 0, featureHash);
		setFeature(c.getFeatureMap(), "whout", 1, featureHash);
		l.add(c);
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "pl", 2, featureHash);
		setFeature(c.getFeatureMap(), "whin", 0, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Nonterminal("verbphrase_coord_1");
		setFeature(c.getFeatureMap(), "pl", 2, featureHash);
		setFeature(c.getFeatureMap(), "whin", 3, featureHash);
		setFeature(c.getFeatureMap(), "whout", 1, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// simple_sentence_2(whin:minus, whout:minus)~>nounphrase(exist:minus), verbphrase_coord_1(pl:minus, whin:minus, whout:minus)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("simple_sentence_2");
		c.setFeature("whin", new StringRef("minus"));
		c.setFeature("whout", new StringRef("minus"));
		l.add(c);
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("minus"));
		l.add(c);
		c = new Nonterminal("verbphrase_coord_1");
		c.setFeature("pl", new StringRef("minus"));
		c.setFeature("whin", new StringRef("minus"));
		c.setFeature("whout", new StringRef("minus"));
		l.add(c);
		addRule(new Rule(l, false));
		
		// verbphrase_coord_1(pl:A, whin:B, whout:C)=>verbphrase_coord_2(pl:A, whin:B, whout:C)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("verbphrase_coord_1");
		setFeature(c.getFeatureMap(), "pl", 0, featureHash);
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 2, featureHash);
		l.add(c);
		c = new Nonterminal("verbphrase_coord_2");
		setFeature(c.getFeatureMap(), "pl", 0, featureHash);
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 2, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// verbphrase_coord_1(pl:A, whin:B, whout:B)~>verbphrase_coord_2(pl:A, whin:B, whout:B), [or], verbphrase_coord_1(pl:A, whin:B, whout:B)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("verbphrase_coord_1");
		setFeature(c.getFeatureMap(), "pl", 0, featureHash);
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 1, featureHash);
		l.add(c);
		c = new Nonterminal("verbphrase_coord_2");
		setFeature(c.getFeatureMap(), "pl", 0, featureHash);
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 1, featureHash);
		l.add(c);
		c = new Terminal("or");
		l.add(c);
		c = new Nonterminal("verbphrase_coord_1");
		setFeature(c.getFeatureMap(), "pl", 0, featureHash);
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 1, featureHash);
		l.add(c);
		addRule(new Rule(l, false));
		
		// verbphrase_coord_2(pl:A, whin:B, whout:C)=>verbphrase_cut(pl:A, whin:B, whout:C)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("verbphrase_coord_2");
		setFeature(c.getFeatureMap(), "pl", 0, featureHash);
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 2, featureHash);
		l.add(c);
		c = new Nonterminal("verbphrase_cut");
		setFeature(c.getFeatureMap(), "pl", 0, featureHash);
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 2, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// verbphrase_coord_2(pl:A, whin:B, whout:B)=>verbphrase_cut(pl:A, whin:B, whout:B), [and], verbphrase_coord_2(pl:A, whin:B, whout:B)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("verbphrase_coord_2");
		setFeature(c.getFeatureMap(), "pl", 0, featureHash);
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 1, featureHash);
		l.add(c);
		c = new Nonterminal("verbphrase_cut");
		setFeature(c.getFeatureMap(), "pl", 0, featureHash);
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 1, featureHash);
		l.add(c);
		c = new Terminal("and");
		l.add(c);
		c = new Nonterminal("verbphrase_coord_2");
		setFeature(c.getFeatureMap(), "pl", 0, featureHash);
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 1, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// verbphrase_cut(that:A, pl:B, whin:C, whout:D)=>verbphrase(neg:minus, that:A, pl:B, whin:C, whout:D)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("verbphrase_cut");
		setFeature(c.getFeatureMap(), "that", 0, featureHash);
		setFeature(c.getFeatureMap(), "pl", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Nonterminal("verbphrase");
		c.setFeature("neg", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "that", 0, featureHash);
		setFeature(c.getFeatureMap(), "pl", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// verbphrase_cut(that:A, pl:B, whin:C, whout:D)~>verbphrase(neg:plus, that:A, pl:B, whin:C, whout:D)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("verbphrase_cut");
		setFeature(c.getFeatureMap(), "that", 0, featureHash);
		setFeature(c.getFeatureMap(), "pl", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Nonterminal("verbphrase");
		c.setFeature("neg", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "that", 0, featureHash);
		setFeature(c.getFeatureMap(), "pl", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		addRule(new Rule(l, false));
		
		// verbphrase(neg:A, that:B, pl:C, whin:D, whout:E)=>verb(verb:full, pl:C, neg:A), nounphrase_cut(that:B, verb:full, whin:D, whout:E)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("verbphrase");
		setFeature(c.getFeatureMap(), "neg", 0, featureHash);
		setFeature(c.getFeatureMap(), "that", 1, featureHash);
		setFeature(c.getFeatureMap(), "pl", 2, featureHash);
		setFeature(c.getFeatureMap(), "whin", 3, featureHash);
		setFeature(c.getFeatureMap(), "whout", 4, featureHash);
		l.add(c);
		c = new Nonterminal("verb");
		c.setFeature("verb", new StringRef("full"));
		setFeature(c.getFeatureMap(), "pl", 2, featureHash);
		setFeature(c.getFeatureMap(), "neg", 0, featureHash);
		l.add(c);
		c = new Nonterminal("nounphrase_cut");
		setFeature(c.getFeatureMap(), "that", 1, featureHash);
		c.setFeature("verb", new StringRef("full"));
		setFeature(c.getFeatureMap(), "whin", 3, featureHash);
		setFeature(c.getFeatureMap(), "whout", 4, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// verbphrase(neg:A, that:B, pl:C, whin:D, whout:E)=>verb(verb:be, pl:C, neg:A), nounphrase_cut(of:plus, that:B, pl:minus, verb:be, whin:D, whout:E)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("verbphrase");
		setFeature(c.getFeatureMap(), "neg", 0, featureHash);
		setFeature(c.getFeatureMap(), "that", 1, featureHash);
		setFeature(c.getFeatureMap(), "pl", 2, featureHash);
		setFeature(c.getFeatureMap(), "whin", 3, featureHash);
		setFeature(c.getFeatureMap(), "whout", 4, featureHash);
		l.add(c);
		c = new Nonterminal("verb");
		c.setFeature("verb", new StringRef("be"));
		setFeature(c.getFeatureMap(), "pl", 2, featureHash);
		setFeature(c.getFeatureMap(), "neg", 0, featureHash);
		l.add(c);
		c = new Nonterminal("nounphrase_cut");
		c.setFeature("of", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "that", 1, featureHash);
		c.setFeature("pl", new StringRef("minus"));
		c.setFeature("verb", new StringRef("be"));
		setFeature(c.getFeatureMap(), "whin", 3, featureHash);
		setFeature(c.getFeatureMap(), "whout", 4, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// verbphrase(neg:A, that:B, pl:minus, whin:C, whout:D)=>verb(verb:be, pl:minus, neg:A), nounphrase_cut(of:minus, that:B, pl:minus, verb:be, whin:C, whout:D)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("verbphrase");
		setFeature(c.getFeatureMap(), "neg", 0, featureHash);
		setFeature(c.getFeatureMap(), "that", 1, featureHash);
		c.setFeature("pl", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Nonterminal("verb");
		c.setFeature("verb", new StringRef("be"));
		c.setFeature("pl", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "neg", 0, featureHash);
		l.add(c);
		c = new Nonterminal("nounphrase_cut");
		c.setFeature("of", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "that", 1, featureHash);
		c.setFeature("pl", new StringRef("minus"));
		c.setFeature("verb", new StringRef("be"));
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// verbphrase(neg:A, that:B, pl:C, whin:D, whout:E)=>verb(verb:be, pl:C, neg:A), ['TRADJ'], nounphrase_cut(that:B, verb:full, whin:D, whout:E)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("verbphrase");
		setFeature(c.getFeatureMap(), "neg", 0, featureHash);
		setFeature(c.getFeatureMap(), "that", 1, featureHash);
		setFeature(c.getFeatureMap(), "pl", 2, featureHash);
		setFeature(c.getFeatureMap(), "whin", 3, featureHash);
		setFeature(c.getFeatureMap(), "whout", 4, featureHash);
		l.add(c);
		c = new Nonterminal("verb");
		c.setFeature("verb", new StringRef("be"));
		setFeature(c.getFeatureMap(), "pl", 2, featureHash);
		setFeature(c.getFeatureMap(), "neg", 0, featureHash);
		l.add(c);
		c = new Terminal("TRADJ");
		l.add(c);
		c = new Nonterminal("nounphrase_cut");
		setFeature(c.getFeatureMap(), "that", 1, featureHash);
		c.setFeature("verb", new StringRef("full"));
		setFeature(c.getFeatureMap(), "whin", 3, featureHash);
		setFeature(c.getFeatureMap(), "whout", 4, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// verbphrase(neg:A, that:B, pl:C, whin:D, whout:E)=>verb(verb:be, pl:C, neg:A), ['PVERB'], nounphrase_cut(that:B, verb:full, whin:D, whout:E)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("verbphrase");
		setFeature(c.getFeatureMap(), "neg", 0, featureHash);
		setFeature(c.getFeatureMap(), "that", 1, featureHash);
		setFeature(c.getFeatureMap(), "pl", 2, featureHash);
		setFeature(c.getFeatureMap(), "whin", 3, featureHash);
		setFeature(c.getFeatureMap(), "whout", 4, featureHash);
		l.add(c);
		c = new Nonterminal("verb");
		c.setFeature("verb", new StringRef("be"));
		setFeature(c.getFeatureMap(), "pl", 2, featureHash);
		setFeature(c.getFeatureMap(), "neg", 0, featureHash);
		l.add(c);
		c = new Terminal("PVERB");
		l.add(c);
		c = new Nonterminal("nounphrase_cut");
		setFeature(c.getFeatureMap(), "that", 1, featureHash);
		c.setFeature("verb", new StringRef("full"));
		setFeature(c.getFeatureMap(), "whin", 3, featureHash);
		setFeature(c.getFeatureMap(), "whout", 4, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// nounphrase_cut(exist:plus, that:A, of:B, def:C, pl:D, verb:E, whin:F, whout:G)=>nounphrase(exist:plus, that:A, of:B, def:C, pl:D, verb:E, whin:F, whout:G)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase_cut");
		c.setFeature("exist", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "that", 0, featureHash);
		setFeature(c.getFeatureMap(), "of", 1, featureHash);
		setFeature(c.getFeatureMap(), "def", 2, featureHash);
		setFeature(c.getFeatureMap(), "pl", 3, featureHash);
		setFeature(c.getFeatureMap(), "verb", 4, featureHash);
		setFeature(c.getFeatureMap(), "whin", 5, featureHash);
		setFeature(c.getFeatureMap(), "whout", 6, featureHash);
		l.add(c);
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "that", 0, featureHash);
		setFeature(c.getFeatureMap(), "of", 1, featureHash);
		setFeature(c.getFeatureMap(), "def", 2, featureHash);
		setFeature(c.getFeatureMap(), "pl", 3, featureHash);
		setFeature(c.getFeatureMap(), "verb", 4, featureHash);
		setFeature(c.getFeatureMap(), "whin", 5, featureHash);
		setFeature(c.getFeatureMap(), "whout", 6, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// nounphrase_cut(exist:minus, that:A, of:B, def:C, pl:D, verb:E, whin:F, whout:G)~>nounphrase(exist:minus, that:A, of:B, def:C, pl:D, verb:E, whin:F, whout:G)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase_cut");
		c.setFeature("exist", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "that", 0, featureHash);
		setFeature(c.getFeatureMap(), "of", 1, featureHash);
		setFeature(c.getFeatureMap(), "def", 2, featureHash);
		setFeature(c.getFeatureMap(), "pl", 3, featureHash);
		setFeature(c.getFeatureMap(), "verb", 4, featureHash);
		setFeature(c.getFeatureMap(), "whin", 5, featureHash);
		setFeature(c.getFeatureMap(), "whout", 6, featureHash);
		l.add(c);
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "that", 0, featureHash);
		setFeature(c.getFeatureMap(), "of", 1, featureHash);
		setFeature(c.getFeatureMap(), "def", 2, featureHash);
		setFeature(c.getFeatureMap(), "pl", 3, featureHash);
		setFeature(c.getFeatureMap(), "verb", 4, featureHash);
		setFeature(c.getFeatureMap(), "whin", 5, featureHash);
		setFeature(c.getFeatureMap(), "whout", 6, featureHash);
		l.add(c);
		addRule(new Rule(l, false));
		
		// nounphrase(exist:plus, that:A, of:minus, def:plus, pl:minus, whin:B, whout:C)=>['PROPERNAME'], that_phrase(that:A, whin:B, whout:C)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "that", 0, featureHash);
		c.setFeature("of", new StringRef("minus"));
		c.setFeature("def", new StringRef("plus"));
		c.setFeature("pl", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 2, featureHash);
		l.add(c);
		c = new Terminal("PROPERNAME");
		l.add(c);
		c = new Nonterminal("that_phrase");
		setFeature(c.getFeatureMap(), "that", 0, featureHash);
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 2, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// nounphrase(exist:plus, that:minus, of:minus, def:plus, pl:minus, whin:A, whout:A)=>var_ante
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("plus"));
		c.setFeature("that", new StringRef("minus"));
		c.setFeature("of", new StringRef("minus"));
		c.setFeature("def", new StringRef("plus"));
		c.setFeature("pl", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "whin", 0, featureHash);
		setFeature(c.getFeatureMap(), "whout", 0, featureHash);
		l.add(c);
		c = new Nonterminal("var_ante");
		l.add(c);
		addRule(new Rule(l, true));
		
		// nounphrase(exist:plus, that:minus, of:minus, def:plus, pl:minus, whin:A, whout:A)~>['DEF_NOUN'(noun:B), 'REFERENCE'(text:C)], <<<(type:noun, hasvar:plus, noun:B, var:C)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("plus"));
		c.setFeature("that", new StringRef("minus"));
		c.setFeature("of", new StringRef("minus"));
		c.setFeature("def", new StringRef("plus"));
		c.setFeature("pl", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "whin", 0, featureHash);
		setFeature(c.getFeatureMap(), "whout", 0, featureHash);
		l.add(c);
		c = new Terminal("DEF_NOUN");
		setFeature(c.getFeatureMap(), "noun", 1, featureHash);
		l.add(c);
		c = new Terminal("REFERENCE");
		setFeature(c.getFeatureMap(), "text", 2, featureHash);
		l.add(c);
		c = new Nonterminal("<<<");
		c.setFeature("type", new StringRef("noun"));
		c.setFeature("hasvar", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "noun", 1, featureHash);
		setFeature(c.getFeatureMap(), "var", 2, featureHash);
		l.add(c);
		addRule(new Rule(l, false));
		
		// nounphrase(exist:plus, that:minus, of:minus, def:plus, pl:minus, whin:A, whout:A)~>['DEF_NOUN'(noun:B)], <<<(type:noun, noun:B)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("plus"));
		c.setFeature("that", new StringRef("minus"));
		c.setFeature("of", new StringRef("minus"));
		c.setFeature("def", new StringRef("plus"));
		c.setFeature("pl", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "whin", 0, featureHash);
		setFeature(c.getFeatureMap(), "whout", 0, featureHash);
		l.add(c);
		c = new Terminal("DEF_NOUN");
		setFeature(c.getFeatureMap(), "noun", 1, featureHash);
		l.add(c);
		c = new Nonterminal("<<<");
		c.setFeature("type", new StringRef("noun"));
		setFeature(c.getFeatureMap(), "noun", 1, featureHash);
		l.add(c);
		addRule(new Rule(l, false));
		
		// nounphrase(exist:plus, that:minus, of:minus, def:plus, pl:minus, whin:A, whout:A)~>['REFERENCE'(text:B)], <<<(hasvar:plus, var:B)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("plus"));
		c.setFeature("that", new StringRef("minus"));
		c.setFeature("of", new StringRef("minus"));
		c.setFeature("def", new StringRef("plus"));
		c.setFeature("pl", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "whin", 0, featureHash);
		setFeature(c.getFeatureMap(), "whout", 0, featureHash);
		l.add(c);
		c = new Terminal("REFERENCE");
		setFeature(c.getFeatureMap(), "text", 1, featureHash);
		l.add(c);
		c = new Nonterminal("<<<");
		c.setFeature("hasvar", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "var", 1, featureHash);
		l.add(c);
		addRule(new Rule(l, false));
		
		// nounphrase(exist:plus, that:A, of:B, pl:minus, whin:C, whout:D)=>[a], noun_constr(that:A, of:B, whin:C, whout:D)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "that", 0, featureHash);
		setFeature(c.getFeatureMap(), "of", 1, featureHash);
		c.setFeature("pl", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Terminal("a");
		l.add(c);
		c = new Nonterminal("noun_constr");
		setFeature(c.getFeatureMap(), "that", 0, featureHash);
		setFeature(c.getFeatureMap(), "of", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// nounphrase(exist:plus, that:A, of:B, pl:minus, whin:C, whout:D)=>[an], noun_constr(that:A, of:B, whin:C, whout:D)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "that", 0, featureHash);
		setFeature(c.getFeatureMap(), "of", 1, featureHash);
		c.setFeature("pl", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		c = new Terminal("an");
		l.add(c);
		c = new Nonterminal("noun_constr");
		setFeature(c.getFeatureMap(), "that", 0, featureHash);
		setFeature(c.getFeatureMap(), "of", 1, featureHash);
		setFeature(c.getFeatureMap(), "whin", 2, featureHash);
		setFeature(c.getFeatureMap(), "whout", 3, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// nounphrase(exist:plus, that:A, of:minus, pl:minus, whin:B, whout:C)=>exist_anon, var_ante, that_phrase(that:A, whin:B, whout:C)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "that", 0, featureHash);
		c.setFeature("of", new StringRef("minus"));
		c.setFeature("pl", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 2, featureHash);
		l.add(c);
		c = new Nonterminal("exist_anon");
		l.add(c);
		c = new Nonterminal("var_ante");
		l.add(c);
		c = new Nonterminal("that_phrase");
		setFeature(c.getFeatureMap(), "that", 0, featureHash);
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 2, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// nounphrase(exist:plus, that:A, of:minus, pl:minus, whin:B, whout:C)=>exist_anon, that_phrase(that:A, whin:B, whout:C)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "that", 0, featureHash);
		c.setFeature("of", new StringRef("minus"));
		c.setFeature("pl", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 2, featureHash);
		l.add(c);
		c = new Nonterminal("exist_anon");
		l.add(c);
		c = new Nonterminal("that_phrase");
		setFeature(c.getFeatureMap(), "that", 0, featureHash);
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 2, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// nounphrase(exist:plus, that:minus, of:minus, pl:plus, verb:full, whin:A, whout:A)=>num_quant, ['NUMBER', 'NOUNPL']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("plus"));
		c.setFeature("that", new StringRef("minus"));
		c.setFeature("of", new StringRef("minus"));
		c.setFeature("pl", new StringRef("plus"));
		c.setFeature("verb", new StringRef("full"));
		setFeature(c.getFeatureMap(), "whin", 0, featureHash);
		setFeature(c.getFeatureMap(), "whout", 0, featureHash);
		l.add(c);
		c = new Nonterminal("num_quant");
		l.add(c);
		c = new Terminal("NUMBER");
		l.add(c);
		c = new Terminal("NOUNPL");
		l.add(c);
		addRule(new Rule(l, true));
		
		// nounphrase(exist:plus, that:minus, of:minus, pl:minus, verb:full, whin:A, whout:A)=>num_quant, [1, 'NOUN']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("plus"));
		c.setFeature("that", new StringRef("minus"));
		c.setFeature("of", new StringRef("minus"));
		c.setFeature("pl", new StringRef("minus"));
		c.setFeature("verb", new StringRef("full"));
		setFeature(c.getFeatureMap(), "whin", 0, featureHash);
		setFeature(c.getFeatureMap(), "whout", 0, featureHash);
		l.add(c);
		c = new Nonterminal("num_quant");
		l.add(c);
		c = new Terminal("1");
		l.add(c);
		c = new Terminal("NOUN");
		l.add(c);
		addRule(new Rule(l, true));
		
		// nounphrase(exist:plus, that:minus, of:minus, pl:minus, whin:right, whout:left)=>[what]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("plus"));
		c.setFeature("that", new StringRef("minus"));
		c.setFeature("of", new StringRef("minus"));
		c.setFeature("pl", new StringRef("minus"));
		c.setFeature("whin", new StringRef("right"));
		c.setFeature("whout", new StringRef("left"));
		l.add(c);
		c = new Terminal("what");
		l.add(c);
		addRule(new Rule(l, true));
		
		// nounphrase(exist:plus, that:minus, of:minus, pl:minus, whin:right, whout:left)=>[who]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("plus"));
		c.setFeature("that", new StringRef("minus"));
		c.setFeature("of", new StringRef("minus"));
		c.setFeature("pl", new StringRef("minus"));
		c.setFeature("whin", new StringRef("right"));
		c.setFeature("whout", new StringRef("left"));
		l.add(c);
		c = new Terminal("who");
		l.add(c);
		addRule(new Rule(l, true));
		
		// nounphrase(exist:plus, that:A, of:B, pl:minus, whin:right, whout:left)=>[which], noun_constr(that:A, of:B, whin:left, whout:left)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "that", 0, featureHash);
		setFeature(c.getFeatureMap(), "of", 1, featureHash);
		c.setFeature("pl", new StringRef("minus"));
		c.setFeature("whin", new StringRef("right"));
		c.setFeature("whout", new StringRef("left"));
		l.add(c);
		c = new Terminal("which");
		l.add(c);
		c = new Nonterminal("noun_constr");
		setFeature(c.getFeatureMap(), "that", 0, featureHash);
		setFeature(c.getFeatureMap(), "of", 1, featureHash);
		c.setFeature("whin", new StringRef("left"));
		c.setFeature("whout", new StringRef("left"));
		l.add(c);
		addRule(new Rule(l, true));
		
		// nounphrase(exist:plus, that:minus, of:minus, pl:plus, whin:right, whout:left)=>[which, 'NOUNPL']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("plus"));
		c.setFeature("that", new StringRef("minus"));
		c.setFeature("of", new StringRef("minus"));
		c.setFeature("pl", new StringRef("plus"));
		c.setFeature("whin", new StringRef("right"));
		c.setFeature("whout", new StringRef("left"));
		l.add(c);
		c = new Terminal("which");
		l.add(c);
		c = new Terminal("NOUNPL");
		l.add(c);
		addRule(new Rule(l, true));
		
		// nounphrase(exist:minus, that:A, of:B, pl:minus, whin:minus, whout:minus)=>[every], noun_constr(that:A, of:B, whin:minus, whout:minus)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "that", 0, featureHash);
		setFeature(c.getFeatureMap(), "of", 1, featureHash);
		c.setFeature("pl", new StringRef("minus"));
		c.setFeature("whin", new StringRef("minus"));
		c.setFeature("whout", new StringRef("minus"));
		l.add(c);
		c = new Terminal("every");
		l.add(c);
		c = new Nonterminal("noun_constr");
		setFeature(c.getFeatureMap(), "that", 0, featureHash);
		setFeature(c.getFeatureMap(), "of", 1, featureHash);
		c.setFeature("whin", new StringRef("minus"));
		c.setFeature("whout", new StringRef("minus"));
		l.add(c);
		addRule(new Rule(l, true));
		
		// nounphrase(exist:minus, that:A, of:minus, pl:minus, whin:minus, whout:minus)=>univ_anon, var_ante, that_phrase(that:A, whin:minus, whout:minus)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "that", 0, featureHash);
		c.setFeature("of", new StringRef("minus"));
		c.setFeature("pl", new StringRef("minus"));
		c.setFeature("whin", new StringRef("minus"));
		c.setFeature("whout", new StringRef("minus"));
		l.add(c);
		c = new Nonterminal("univ_anon");
		l.add(c);
		c = new Nonterminal("var_ante");
		l.add(c);
		c = new Nonterminal("that_phrase");
		setFeature(c.getFeatureMap(), "that", 0, featureHash);
		c.setFeature("whin", new StringRef("minus"));
		c.setFeature("whout", new StringRef("minus"));
		l.add(c);
		addRule(new Rule(l, true));
		
		// nounphrase(exist:minus, that:A, of:minus, pl:minus, whin:minus, whout:minus)=>univ_anon, that_phrase(that:A, whin:minus, whout:minus)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "that", 0, featureHash);
		c.setFeature("of", new StringRef("minus"));
		c.setFeature("pl", new StringRef("minus"));
		c.setFeature("whin", new StringRef("minus"));
		c.setFeature("whout", new StringRef("minus"));
		l.add(c);
		c = new Nonterminal("univ_anon");
		l.add(c);
		c = new Nonterminal("that_phrase");
		setFeature(c.getFeatureMap(), "that", 0, featureHash);
		c.setFeature("whin", new StringRef("minus"));
		c.setFeature("whout", new StringRef("minus"));
		l.add(c);
		addRule(new Rule(l, true));
		
		// nounphrase(exist:minus, that:A, of:B, pl:minus, whin:minus, whout:minus)=>[no], noun_constr(that:A, of:B, whin:minus, whout:minus)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "that", 0, featureHash);
		setFeature(c.getFeatureMap(), "of", 1, featureHash);
		c.setFeature("pl", new StringRef("minus"));
		c.setFeature("whin", new StringRef("minus"));
		c.setFeature("whout", new StringRef("minus"));
		l.add(c);
		c = new Terminal("no");
		l.add(c);
		c = new Nonterminal("noun_constr");
		setFeature(c.getFeatureMap(), "that", 0, featureHash);
		setFeature(c.getFeatureMap(), "of", 1, featureHash);
		c.setFeature("whin", new StringRef("minus"));
		c.setFeature("whout", new StringRef("minus"));
		l.add(c);
		addRule(new Rule(l, true));
		
		// nounphrase(exist:minus, that:A, of:minus, pl:minus, whin:minus, whout:minus)=>neg_anon, var_ante, that_phrase(that:A, whin:minus, whout:minus)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "that", 0, featureHash);
		c.setFeature("of", new StringRef("minus"));
		c.setFeature("pl", new StringRef("minus"));
		c.setFeature("whin", new StringRef("minus"));
		c.setFeature("whout", new StringRef("minus"));
		l.add(c);
		c = new Nonterminal("neg_anon");
		l.add(c);
		c = new Nonterminal("var_ante");
		l.add(c);
		c = new Nonterminal("that_phrase");
		setFeature(c.getFeatureMap(), "that", 0, featureHash);
		c.setFeature("whin", new StringRef("minus"));
		c.setFeature("whout", new StringRef("minus"));
		l.add(c);
		addRule(new Rule(l, true));
		
		// nounphrase(exist:minus, that:A, of:minus, pl:minus, whin:minus, whout:minus)=>neg_anon, that_phrase(that:A, whin:minus, whout:minus)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("nounphrase");
		c.setFeature("exist", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "that", 0, featureHash);
		c.setFeature("of", new StringRef("minus"));
		c.setFeature("pl", new StringRef("minus"));
		c.setFeature("whin", new StringRef("minus"));
		c.setFeature("whout", new StringRef("minus"));
		l.add(c);
		c = new Nonterminal("neg_anon");
		l.add(c);
		c = new Nonterminal("that_phrase");
		setFeature(c.getFeatureMap(), "that", 0, featureHash);
		c.setFeature("whin", new StringRef("minus"));
		c.setFeature("whout", new StringRef("minus"));
		l.add(c);
		addRule(new Rule(l, true));
		
		// noun_constr(that:A, of:minus, whin:B, whout:C)=>noun_ante, that_phrase(that:A, whin:B, whout:C)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("noun_constr");
		setFeature(c.getFeatureMap(), "that", 0, featureHash);
		c.setFeature("of", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 2, featureHash);
		l.add(c);
		c = new Nonterminal("noun_ante");
		l.add(c);
		c = new Nonterminal("that_phrase");
		setFeature(c.getFeatureMap(), "that", 0, featureHash);
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 2, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// noun_constr(that:A, of:plus, whin:B, whout:C)=>['NOUNOF'], nounphrase_cut(that:A, whin:B, whout:C)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("noun_constr");
		setFeature(c.getFeatureMap(), "that", 0, featureHash);
		c.setFeature("of", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 2, featureHash);
		l.add(c);
		c = new Terminal("NOUNOF");
		l.add(c);
		c = new Nonterminal("nounphrase_cut");
		setFeature(c.getFeatureMap(), "that", 0, featureHash);
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 2, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// noun_ante=>['NOUN'(text:A)], newvar(var:B), >>>(type:noun, hasvar:plus, noun:A, var:B)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("noun_ante");
		l.add(c);
		c = new Terminal("NOUN");
		setFeature(c.getFeatureMap(), "text", 0, featureHash);
		l.add(c);
		c = new Nonterminal("newvar");
		setFeature(c.getFeatureMap(), "var", 1, featureHash);
		l.add(c);
		c = new Nonterminal(">>>");
		c.setFeature("type", new StringRef("noun"));
		c.setFeature("hasvar", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "noun", 0, featureHash);
		setFeature(c.getFeatureMap(), "var", 1, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// noun_ante=>['NOUN'(text:A)], >>>(type:noun, hasvar:minus, noun:A)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("noun_ante");
		l.add(c);
		c = new Terminal("NOUN");
		setFeature(c.getFeatureMap(), "text", 0, featureHash);
		l.add(c);
		c = new Nonterminal(">>>");
		c.setFeature("type", new StringRef("noun"));
		c.setFeature("hasvar", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "noun", 0, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// var_ante=>newvar(var:A), >>>(type:var, hasvar:plus, var:A)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("var_ante");
		l.add(c);
		c = new Nonterminal("newvar");
		setFeature(c.getFeatureMap(), "var", 0, featureHash);
		l.add(c);
		c = new Nonterminal(">>>");
		c.setFeature("type", new StringRef("var"));
		c.setFeature("hasvar", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "var", 0, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// newvar(var:A)=>['VARIABLE'(text:A)], </<(hasvar:plus, var:A)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("newvar");
		setFeature(c.getFeatureMap(), "var", 0, featureHash);
		l.add(c);
		c = new Terminal("VARIABLE");
		setFeature(c.getFeatureMap(), "text", 0, featureHash);
		l.add(c);
		c = new Nonterminal("</<");
		c.setFeature("hasvar", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "var", 0, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// verb(verb:be, neg:minus, pl:minus)=>[is]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("verb");
		c.setFeature("verb", new StringRef("be"));
		c.setFeature("neg", new StringRef("minus"));
		c.setFeature("pl", new StringRef("minus"));
		l.add(c);
		c = new Terminal("is");
		l.add(c);
		addRule(new Rule(l, true));
		
		// verb(verb:be, neg:plus, pl:minus)=>['is not']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("verb");
		c.setFeature("verb", new StringRef("be"));
		c.setFeature("neg", new StringRef("plus"));
		c.setFeature("pl", new StringRef("minus"));
		l.add(c);
		c = new Terminal("is not");
		l.add(c);
		addRule(new Rule(l, true));
		
		// verb(verb:be, neg:plus, pl:minus)=>[is, not]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("verb");
		c.setFeature("verb", new StringRef("be"));
		c.setFeature("neg", new StringRef("plus"));
		c.setFeature("pl", new StringRef("minus"));
		l.add(c);
		c = new Terminal("is");
		l.add(c);
		c = new Terminal("not");
		l.add(c);
		addRule(new Rule(l, true));
		
		// verb(verb:be, neg:minus, pl:plus)=>[are]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("verb");
		c.setFeature("verb", new StringRef("be"));
		c.setFeature("neg", new StringRef("minus"));
		c.setFeature("pl", new StringRef("plus"));
		l.add(c);
		c = new Terminal("are");
		l.add(c);
		addRule(new Rule(l, true));
		
		// verb(verb:be, neg:plus, pl:plus)=>['are not']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("verb");
		c.setFeature("verb", new StringRef("be"));
		c.setFeature("neg", new StringRef("plus"));
		c.setFeature("pl", new StringRef("plus"));
		l.add(c);
		c = new Terminal("are not");
		l.add(c);
		addRule(new Rule(l, true));
		
		// verb(verb:be, neg:plus, pl:plus)=>[are, not]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("verb");
		c.setFeature("verb", new StringRef("be"));
		c.setFeature("neg", new StringRef("plus"));
		c.setFeature("pl", new StringRef("plus"));
		l.add(c);
		c = new Terminal("are");
		l.add(c);
		c = new Terminal("not");
		l.add(c);
		addRule(new Rule(l, true));
		
		// verb(verb:full, neg:minus, pl:minus)=>['VERB']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("verb");
		c.setFeature("verb", new StringRef("full"));
		c.setFeature("neg", new StringRef("minus"));
		c.setFeature("pl", new StringRef("minus"));
		l.add(c);
		c = new Terminal("VERB");
		l.add(c);
		addRule(new Rule(l, true));
		
		// verb(verb:full, neg:plus, pl:minus)=>['does not', 'VERBINF']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("verb");
		c.setFeature("verb", new StringRef("full"));
		c.setFeature("neg", new StringRef("plus"));
		c.setFeature("pl", new StringRef("minus"));
		l.add(c);
		c = new Terminal("does not");
		l.add(c);
		c = new Terminal("VERBINF");
		l.add(c);
		addRule(new Rule(l, true));
		
		// verb(verb:full, neg:minus, pl:plus)=>['VERBINF']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("verb");
		c.setFeature("verb", new StringRef("full"));
		c.setFeature("neg", new StringRef("minus"));
		c.setFeature("pl", new StringRef("plus"));
		l.add(c);
		c = new Terminal("VERBINF");
		l.add(c);
		addRule(new Rule(l, true));
		
		// verb(verb:full, neg:plus, pl:plus)=>['do not', 'VERBINF']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("verb");
		c.setFeature("verb", new StringRef("full"));
		c.setFeature("neg", new StringRef("plus"));
		c.setFeature("pl", new StringRef("plus"));
		l.add(c);
		c = new Terminal("do not");
		l.add(c);
		c = new Terminal("VERBINF");
		l.add(c);
		addRule(new Rule(l, true));
		
		// that_phrase(that:minus, whin:A, whout:A)=>[]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("that_phrase");
		c.setFeature("that", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "whin", 0, featureHash);
		setFeature(c.getFeatureMap(), "whout", 0, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// that_phrase(that:plus, whin:A, whout:B)=>rel_pron, that_phrase_1(whin:A, whout:B)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("that_phrase");
		c.setFeature("that", new StringRef("plus"));
		setFeature(c.getFeatureMap(), "whin", 0, featureHash);
		setFeature(c.getFeatureMap(), "whout", 1, featureHash);
		l.add(c);
		c = new Nonterminal("rel_pron");
		l.add(c);
		c = new Nonterminal("that_phrase_1");
		setFeature(c.getFeatureMap(), "whin", 0, featureHash);
		setFeature(c.getFeatureMap(), "whout", 1, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// that_phrase_1(whin:A, whout:B)=>that_phrase_2(whin:A, whout:B)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("that_phrase_1");
		setFeature(c.getFeatureMap(), "whin", 0, featureHash);
		setFeature(c.getFeatureMap(), "whout", 1, featureHash);
		l.add(c);
		c = new Nonterminal("that_phrase_2");
		setFeature(c.getFeatureMap(), "whin", 0, featureHash);
		setFeature(c.getFeatureMap(), "whout", 1, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// that_phrase_1(whin:A, whout:A)~>that_phrase_2(that:minus, whin:A, whout:A), or_rel_pron, that_phrase_1(whin:A, whout:A)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("that_phrase_1");
		setFeature(c.getFeatureMap(), "whin", 0, featureHash);
		setFeature(c.getFeatureMap(), "whout", 0, featureHash);
		l.add(c);
		c = new Nonterminal("that_phrase_2");
		c.setFeature("that", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "whin", 0, featureHash);
		setFeature(c.getFeatureMap(), "whout", 0, featureHash);
		l.add(c);
		c = new Nonterminal("or_rel_pron");
		l.add(c);
		c = new Nonterminal("that_phrase_1");
		setFeature(c.getFeatureMap(), "whin", 0, featureHash);
		setFeature(c.getFeatureMap(), "whout", 0, featureHash);
		l.add(c);
		addRule(new Rule(l, false));
		
		// that_phrase_2(that:A, whin:B, whout:B)=>verbphrase_cut(that:minus, pl:minus, whin:B, whout:B), and_rel_pron, that_phrase_2(that:A, whin:B, whout:B)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("that_phrase_2");
		setFeature(c.getFeatureMap(), "that", 0, featureHash);
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 1, featureHash);
		l.add(c);
		c = new Nonterminal("verbphrase_cut");
		c.setFeature("that", new StringRef("minus"));
		c.setFeature("pl", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 1, featureHash);
		l.add(c);
		c = new Nonterminal("and_rel_pron");
		l.add(c);
		c = new Nonterminal("that_phrase_2");
		setFeature(c.getFeatureMap(), "that", 0, featureHash);
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 1, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// that_phrase_2(that:A, whin:B, whout:C)=>verbphrase_cut(that:A, pl:minus, whin:B, whout:C)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("that_phrase_2");
		setFeature(c.getFeatureMap(), "that", 0, featureHash);
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 2, featureHash);
		l.add(c);
		c = new Nonterminal("verbphrase_cut");
		setFeature(c.getFeatureMap(), "that", 0, featureHash);
		c.setFeature("pl", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "whin", 1, featureHash);
		setFeature(c.getFeatureMap(), "whout", 2, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// that_phrase_2(that:minus, whin:A, whout:B)=>nounphrase_cut(that:minus, verb:full, pl:C, whin:A, whout:B), verb(verb:full, pl:C)
		l.clear();
		featureHash.clear();
		c = new Nonterminal("that_phrase_2");
		c.setFeature("that", new StringRef("minus"));
		setFeature(c.getFeatureMap(), "whin", 0, featureHash);
		setFeature(c.getFeatureMap(), "whout", 1, featureHash);
		l.add(c);
		c = new Nonterminal("nounphrase_cut");
		c.setFeature("that", new StringRef("minus"));
		c.setFeature("verb", new StringRef("full"));
		setFeature(c.getFeatureMap(), "pl", 2, featureHash);
		setFeature(c.getFeatureMap(), "whin", 0, featureHash);
		setFeature(c.getFeatureMap(), "whout", 1, featureHash);
		l.add(c);
		c = new Nonterminal("verb");
		c.setFeature("verb", new StringRef("full"));
		setFeature(c.getFeatureMap(), "pl", 2, featureHash);
		l.add(c);
		addRule(new Rule(l, true));
		
		// rel_pron=>[that]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("rel_pron");
		l.add(c);
		c = new Terminal("that");
		l.add(c);
		addRule(new Rule(l, true));
		
		// or_rel_pron=>[or], rel_pron
		l.clear();
		featureHash.clear();
		c = new Nonterminal("or_rel_pron");
		l.add(c);
		c = new Terminal("or");
		l.add(c);
		c = new Nonterminal("rel_pron");
		l.add(c);
		addRule(new Rule(l, true));
		
		// or_rel_pron=>['or that']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("or_rel_pron");
		l.add(c);
		c = new Terminal("or that");
		l.add(c);
		addRule(new Rule(l, true));
		
		// and_rel_pron=>[and], rel_pron
		l.clear();
		featureHash.clear();
		c = new Nonterminal("and_rel_pron");
		l.add(c);
		c = new Terminal("and");
		l.add(c);
		c = new Nonterminal("rel_pron");
		l.add(c);
		addRule(new Rule(l, true));
		
		// and_rel_pron=>['and that']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("and_rel_pron");
		l.add(c);
		c = new Terminal("and that");
		l.add(c);
		addRule(new Rule(l, true));
		
		// exist_anon=>[something]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("exist_anon");
		l.add(c);
		c = new Terminal("something");
		l.add(c);
		addRule(new Rule(l, true));
		
		// exist_anon=>[somebody]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("exist_anon");
		l.add(c);
		c = new Terminal("somebody");
		l.add(c);
		addRule(new Rule(l, true));
		
		// univ_anon=>[everything]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("univ_anon");
		l.add(c);
		c = new Terminal("everything");
		l.add(c);
		addRule(new Rule(l, true));
		
		// univ_anon=>[everybody]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("univ_anon");
		l.add(c);
		c = new Terminal("everybody");
		l.add(c);
		addRule(new Rule(l, true));
		
		// neg_anon=>[nothing]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("neg_anon");
		l.add(c);
		c = new Terminal("nothing");
		l.add(c);
		addRule(new Rule(l, true));
		
		// neg_anon=>[nobody]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("neg_anon");
		l.add(c);
		c = new Terminal("nobody");
		l.add(c);
		addRule(new Rule(l, true));
		
		// num_quant=>['at least']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("num_quant");
		l.add(c);
		c = new Terminal("at least");
		l.add(c);
		addRule(new Rule(l, true));
		
		// num_quant=>['at most']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("num_quant");
		l.add(c);
		c = new Terminal("at most");
		l.add(c);
		addRule(new Rule(l, true));
		
		// num_quant=>['less than']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("num_quant");
		l.add(c);
		c = new Terminal("less than");
		l.add(c);
		addRule(new Rule(l, true));
		
		// num_quant=>['more than']
		l.clear();
		featureHash.clear();
		c = new Nonterminal("num_quant");
		l.add(c);
		c = new Terminal("more than");
		l.add(c);
		addRule(new Rule(l, true));
		
		// num_quant=>[exactly]
		l.clear();
		featureHash.clear();
		c = new Nonterminal("num_quant");
		l.add(c);
		c = new Terminal("exactly");
		l.add(c);
		addRule(new Rule(l, true));

	}
	
	private void setFeature(FeatureMap fm, String featureName, int varID, HashMap<Integer, StringRef> featureHash) {
		if (featureHash.get(varID) == null) {
			StringRef stringRef = new StringRef();
			fm.setFeature(featureName, stringRef);
			featureHash.put(varID, stringRef);
		} else {
			fm.setFeature(featureName, featureHash.get(varID));
		}
	}
	
}